'
' ####################
' #####  PROLOG  #####
' ####################
'
'Conn prob defined by distance and response correlation
'Syn strength prop to clustering
'
' Paul Bush 2015
'
VERSION "1.00"
'
	IMPORT "xst"				' Standard library : required by most programs
	IMPORT "xsx"				' Extended standard library
	IMPORT "xio"				' Console input/ouput library

	IMPORT "xma"
'	IMPORT "xst_s.lib"
' IMPORT "xsx_s.lib"
' IMPORT "xio_s.lib"

	IMPORT "gdi32"			' gdi32.dll
	IMPORT "user32"		  ' user32.dll
	IMPORT "kernel32"	  ' kernel32.dll
'	IMPORT "shell32"		' shell32.dll
'	IMPORT "msvcrt"		  ' msvcrt.dll
	IMPORT "WinX"				' GUI library
	
	IMPORT  "opengl32"
	IMPORT  "glu32"
	IMPORT	"glfw"

	$$M_STARTRAT = 100
	$$M_ATT = 101
	$$M_STIM = 102
	$$M_CONN = 103
	$$M_CLEAR = 104
	$$M_STARTCAT = 105
	$$M_DYN = 106
	$$M_QUIT = 107
	$$M_OR = 200
	$$M_SPFQ = 201
	$$M_RND = 202
	$$M_P4 = 203
	$$M_CLEARATT = 204
	$$M_CLOSEST = 300
	$$M_2CLOSEST = 301
	$$M_CLEARSTIM = 302
	$$M_STIMDISTANCES = 303
	$$M_COMBOSTIM = 304
	$$M_CHANGESTIM = 305
	$$C_FIRST = 400
	$$C_SECOND = 401
	$$M_WRITECONN = 500
	$$M_READCONN = 501
	$$M_SHOWCONN = 502
	$$M_CLEARCONN = 503
	$$M_DISPLAYCONN = 504
	$$M_COMBOCONN = 505
	$$M_SYNSTR = 506
'	$$M_COMBOCORR = 507
	$$M_DISPLAYCORR = 508
	$$M_SHOWCORR = 509
	$$M_CONNSTR = 510
	$$M_COMMCELLS = 511
	$$M_DISPLAYPRECONN = 512
	$$M_DISPLAYPRECORR = 513
	$$M_SHOWPRECORR = 514
	$$M_CONNDIST = 515
	$$M_EPSPORIENT = 516
	$$M_PARAMSYN = 517
	$$M_PREPARAMSYN = 518
	$$M_NORMPRE = 519
	$$M_NORMPOST = 520
	$$M_RECIPAMP = 521
	$$M_NeighborAffinity = 522
	$$M_STARTDYN = 600
	$$M_CELLVM = 601
	$$M_ALLCELLS = 602
	$$M_COMBODYN = 603
	$$M_RERUNDYN = 604
	$$M_CHANGEDYN = 605
	$$M_STOPDYN = 606
	$$M_VARDYN = 607
	$$M_DISPDYN = 608
	$$M_TOTDYN = 609
	$$M_RODYN = 610

	DECLARE FUNCTION Entry ()
	DECLARE FUNCTION Shut_Down (return_code)
	DECLARE FUNCTION onCommand (id, code, hWnd)
	DECLARE FUNCTION StartSim (id)
	DECLARE FUNCTION Graphics (gid)
	DECLARE FUNCTION AssignAttributes (id)
	DECLARE FUNCTION Stimulus (stim)
	DECLARE FUNCTION SINGLE CalculateDistance (x0!,x1!,x2!,x3!,y0!,y1!,y2!,y3!)
	DECLARE	FUNCTION SINGLE CalculatePhyscialDistance (x1,y1,x2,y2)
	DECLARE FUNCTION SINGLE CalculateCellDistance (x0!,x1!,x2!,x3!,y0!,y1!,y2!,y3!)
	DECLARE	FUNCTION ConnectCells (id)
	DECLARE	FUNCTION CalcConnect (x,y)
	DECLARE	FUNCTION InitDynamics ()
	DECLARE	FUNCTION CellDynamics ()
	
'
' ######################
' #####  Entry ()  #####
' ######################
'
FUNCTION Entry ()
	SHARED currentPen
	SHARED redPen
	SHARED greenPen
	SHARED bluePen
	SHARED magentaPen
	SHARED blackPen
	SHARED whitePen
	SHARED	Pen0
	SHARED	Pen1
	SHARED	Pen2
	SHARED	Pen3
	SHARED	Pen4
	SHARED	Pen5
	SHARED	Pen6
	SHARED	Pen7
	SHARED	Pen8
	SHARED	Pen9
	SHARED	Pen10
	SHARED	Pen11
	SHARED	Pen12
	SHARED	Pen13
	SHARED	Pen14
	SHARED	Pen15
	SHARED	Pen16
	SHARED	Pen17
	SHARED	Pen18
	SHARED	Pen19
	SHARED	Pen20
	SHARED	Pen21
	SHARED	Pen22
	SHARED	Pen23
	SHARED	Pen24
	SHARED	Pen25
	SHARED	Brush0
	SHARED	Brush1
	SHARED	Brush2
	SHARED	Brush3
	SHARED	Brush4
	SHARED	Brush5
	SHARED	Brush6
	SHARED	Brush7
	SHARED	Brush8
	SHARED	Brush9
	SHARED	Brush10
	SHARED	Brush11
	SHARED	Brush12
	SHARED	Brush13
	SHARED	Brush14
	SHARED	Brush15
	SHARED	Brush16
	SHARED	Brush17
	SHARED	Brush18
	SHARED	Brush19
	SHARED	Brush20
	SHARED	Brush21
	SHARED	Brush22
	SHARED	Brush23
	SHARED	Brush24
	SHARED	Brush25
	SHARED currentBrush
	SHARED magentaBrush
	SHARED blackBrush
	SHARED whiteBrush
	SHARED toggle
	toggle = 0
	
	XioCreateConsole (@"Console", 100)

' add some rows to console buffer
	hStdOut = XioGetStdOut ()
	XioSetConsoleBufferSize (hStdOut, 0, 1000)
	
	' initialise the WinX library, WinX will crash if you don't do this
	IF WinX () THEN QUIT (0)

	' make the main window
	#winMain = WinXNewWindow (0, "Control", 630, -1, 400, 50, $$XWSS_APP, 0, 0, 0)

	'this is a good place to add controls such as status bars and buttons to your window
	MoveWindow (WinXAddButton (#winMain, "Init Rat", 0, $$M_STARTRAT), 2, 2, 50, 20, $$TRUE)
	MoveWindow (WinXAddButton (#winMain, "Init Cat", 0, $$M_STARTCAT), 52, 2, 50, 20, $$TRUE)
	MoveWindow (WinXAddButton (#winMain, "Attributes", 0, $$M_ATT), 102, 2, 60, 20, $$TRUE)
	MoveWindow (WinXAddButton (#winMain, "Stimulus", 0, $$M_STIM), 164, 2, 50, 20, $$TRUE)
	MoveWindow (WinXAddButton (#winMain, "Connect", 0, $$M_CONN), 216, 2, 50, 20, $$TRUE)
	MoveWindow (WinXAddButton (#winMain, "Dynamics", 0, $$M_DYN), 268, 2, 50, 20, $$TRUE)
	MoveWindow (WinXAddButton (#winMain, "QUIT", 0, $$M_QUIT), 320, 2, 30, 20, $$TRUE)

	'remember to register callbacks
	WinXRegOnCommand (#winMain, &onCommand())

	' make the pens
	penWidth = 1
	Pen0 = CreatePen ($$PS_SOLID, penWidth, 0x00FF0000)
	Pen1 = CreatePen ($$PS_SOLID, penWidth, 0x00FF2700)
	Pen2 = CreatePen ($$PS_SOLID, penWidth, 0x00FF4F00)
	Pen3 = CreatePen ($$PS_SOLID, penWidth, 0x00FF7700)
	Pen4 = CreatePen ($$PS_SOLID, penWidth, 0x00FF9f00)
	Pen5 = CreatePen ($$PS_SOLID, penWidth, 0x00FFc700)
	Pen6 = CreatePen ($$PS_SOLID, penWidth, 0x00FFef00)
	Pen7 = CreatePen ($$PS_SOLID, penWidth, 0x00e6FF00)
	Pen8 = CreatePen ($$PS_SOLID, penWidth, 0x00beFF00)
	Pen9 = CreatePen ($$PS_SOLID, penWidth, 0x0096FF00)
	Pen10 = CreatePen ($$PS_SOLID, penWidth, 0x006eFF00)
	Pen11 = CreatePen ($$PS_SOLID, penWidth, 0x0046FF00)
	Pen12 = CreatePen ($$PS_SOLID, penWidth, 0x0029FF00)
	Pen13 = CreatePen ($$PS_SOLID, penWidth, 0x0000FF09)
	Pen14 = CreatePen ($$PS_SOLID, penWidth, 0x0000FF31)
	Pen15 = CreatePen ($$PS_SOLID, penWidth, 0x0000FF5a)
	Pen16 = CreatePen ($$PS_SOLID, penWidth, 0x0000FF81)
	Pen17 = CreatePen ($$PS_SOLID, penWidth, 0x0000FFa9)
	Pen18 = CreatePen ($$PS_SOLID, penWidth, 0x0000FFd1)
	Pen19 = CreatePen ($$PS_SOLID, penWidth, 0x0000FFf9)
	Pen20 = CreatePen ($$PS_SOLID, penWidth, 0x0000dcFF)
	Pen21 = CreatePen ($$PS_SOLID, penWidth, 0x0000b4FF)
	Pen22 = CreatePen ($$PS_SOLID, penWidth, 0x00008cFF)
	Pen23 = CreatePen ($$PS_SOLID, penWidth, 0x000063FF)
	Pen24 = CreatePen ($$PS_SOLID, penWidth, 0x00003bFF)
	Pen25 = CreatePen ($$PS_SOLID, penWidth, 0x000013FF)
	
	redPen = CreatePen ($$PS_SOLID, penWidth, 0x000000FF)
	greenPen = CreatePen ($$PS_SOLID, penWidth, 0x00008000)
	bluePen = CreatePen ($$PS_SOLID, penWidth, 0x00FF0000)
	magentaPen = CreatePen ($$PS_SOLID, penWidth, 0x00FF00FF)
	blackPen = CreatePen ($$PS_SOLID, penWidth, 0x00000000)
	whitePen = CreatePen ($$PS_SOLID, penWidth, 0x00FFFFFF)
	currentPen = redPen
	magentaBrush = CreateSolidBrush(0x00FF00FF)
	blackBrush = CreateSolidBrush(0x00000000)
	whiteBrush = CreateSolidBrush(0x00FFFFFF)

	Brush0 = CreateSolidBrush(0x00FF0000)
	Brush1 = CreateSolidBrush(0x00FF2700)
	Brush2 = CreateSolidBrush(0x00FF4F00)
	Brush3 = CreateSolidBrush(0x00FF7700)
	Brush4 = CreateSolidBrush(0x00FF9f00)
	Brush5 = CreateSolidBrush(0x00FFc700)
	Brush6 = CreateSolidBrush(0x00FFef00)
	Brush7 = CreateSolidBrush(0x00e6FF00)
	Brush8 = CreateSolidBrush(0x00beFF00)
	Brush9 = CreateSolidBrush(0x0096FF00)
	Brush10 = CreateSolidBrush(0x006eFF00)
	Brush11 = CreateSolidBrush(0x0046FF00)
	Brush12 = CreateSolidBrush(0x0029FF00)
	Brush13 = CreateSolidBrush(0x0000FF09)
	Brush14 = CreateSolidBrush(0x0000FF31)
	Brush15 = CreateSolidBrush(0x0000FF5a)
	Brush16 = CreateSolidBrush(0x0000FF81)
	Brush17 = CreateSolidBrush(0x0000FFa9)
	Brush18 = CreateSolidBrush(0x0000FFd1)
	Brush19 = CreateSolidBrush(0x0000FFf9)
	Brush20 = CreateSolidBrush(0x0000dcFF)
	Brush21 = CreateSolidBrush(0x0000b4FF)
	Brush22 = CreateSolidBrush(0x00008cFF)
	Brush23 = CreateSolidBrush(0x000063FF)
	Brush24 = CreateSolidBrush(0x00003bFF)
	Brush25 = CreateSolidBrush(0x000013FF)

	' display the window
	WinXDisplay (#winMain)

	WinXDoEvents ()
	
END FUNCTION
	
FUNCTION onCommand (id, code, hWnd)

	SHARED orOffset!
	SHARED #clearWin
	SHARED totCells
	SHARED maxPhysDist!
	SHARED showx
	SHARED showy
	SHARED listSelect
	SHARED cellsAtDist[]
	SHARED endTime 
	SHARED time 
	SHARED ffCondMult!
	SHARED gEps#
	SHARED gIps#
	SHARED fbCondMult!
	SHARED toggle
	SHARED spikeCount[]
	SHARED maxSp!
	SHARED bkCondMult!
	SHARED NAff
	SHARED vAhp
	SHARED cellNoise!
	SHARED stimNoise!

	SELECT CASE id
	
		CASE $$M_STARTRAT
			StartSim ($$M_STARTRAT)

		CASE $$M_STARTCAT
			StartSim ($$M_STARTCAT)
	
		CASE $$M_QUIT
			Shut_Down(0)

		CASE $$M_ATT
			#winAtt = WinXNewWindow (0, "Attributes", - 1, -1, 870, 900, $$XWSS_APP, 0, 0, 0)
			MoveWindow (WinXAddButton (#winAtt, "Or", 0, $$M_OR), 2, 2, 40, 20, $$TRUE)
			MoveWindow (WinXAddButton (#winAtt, "SPFq", 0, $$M_SPFQ), 42, 2, 40, 20, $$TRUE)
			MoveWindow (WinXAddButton (#winAtt, "Rnd", 0, $$M_RND), 84, 2, 40, 20, $$TRUE)
			MoveWindow (WinXAddButton (#winAtt, "P4", 0, $$M_P4), 126, 2, 40, 20, $$TRUE)
			MoveWindow (WinXAddButton (#winAtt, "CLEAR", 0, $$M_CLEARATT), 168, 2, 40, 20, $$TRUE)
			WinXRegOnCommand (#winAtt, &onCommand())
			WinXDisplay (#winAtt)
	
		CASE $$M_STIM
			totCells = 100
			title$ = STRING(totCells) + " cells best matching stimulus"
			#winStim = WinXNewWindow (0, title$, - 1, -1, 870, 900, $$XWSS_APP, 0, 0, 0)

			orOffset! = 0
			Stimulus ($$C_FIRST)

			MoveWindow (WinXAddButton (#winStim, "Cells matching stim", 0, $$M_CLOSEST), 2, 2, 100, 20, $$TRUE)
			MoveWindow (WinXAddButton (#winStim, "Cells matching 2 stim", 0, $$M_2CLOSEST), 104, 2, 120, 20, $$TRUE)
			MoveWindow (WinXAddButton (#winStim, "CLEAR", 0, $$M_CLEARSTIM), 226, 2, 40, 20, $$TRUE)
			MoveWindow (WinXAddButton (#winStim, "Distances", 0, $$M_STIMDISTANCES), 268, 2, 70, 20, $$TRUE)

			#comboStim = WinXAddComboBox (#winStim, 120, $$TRUE, 0, $$M_COMBOSTIM)
			MoveWindow (#comboStim, 340, 2, 60, 20, $$TRUE)
			WinXComboBox_AddItem (#comboStim, -1, 0, "orOffset!", 0, 0)
			MoveWindow (WinXAddButton (#winStim, "ENTER", 0, $$M_CHANGESTIM), 402, 2, 50, 20, $$TRUE)

			WinXRegOnCommand (#winStim, &onCommand())
			WinXDisplay (#winStim)
	
		CASE $$M_CONN
			#winConn = WinXNewWindow (0, "Connections", 1000, 100, 870, 900, $$XWSS_APP, 0, 0, 0)			
			MoveWindow (WinXAddButton (#winConn, "Make new connections", 0, $$M_WRITECONN), 2, 2, 120, 20, $$TRUE)
			MoveWindow (WinXAddButton (#winConn, "Load existing connections", 0, $$M_READCONN), 122, 2, 140, 20, $$TRUE)
			MoveWindow (WinXAddButton (#winConn, "CLEAR", 0, $$M_CLEARCONN), 264, 2, 40, 20, $$TRUE)
			#comboConn = WinXAddComboBox (#winConn, 120, $$TRUE, 0, $$M_COMBOCONN)
			MoveWindow (#comboConn, 306, 2, 50, 20, $$TRUE)	
			WinXComboBox_AddItem (#comboConn, -1, 0, "x", 0, 0)
			WinXComboBox_AddItem (#comboConn, -1, 0, "y", 0, 0)	
			MoveWindow (WinXAddButton (#winConn, "Post Syn Str", 0, $$M_DISPLAYCONN), 358, 2, 90, 20, $$TRUE)
			MoveWindow (WinXAddButton (#winConn, "POST CORR", 0, $$M_DISPLAYCORR), 450, 2, 70, 20, $$TRUE)
			MoveWindow (WinXAddButton (#winConn, "Pre Syn Str", 0, $$M_DISPLAYPRECONN), 522, 2, 80, 20, $$TRUE)
			MoveWindow (WinXAddButton (#winConn, "PRE CORR", 0, $$M_DISPLAYPRECORR), 604, 2, 70, 20, $$TRUE)
			WinXRegOnCommand (#winConn, &onCommand())
			WinXDisplay (#winConn)
			#winConnGraph = WinXNewWindow (0, "Graphs", 20, 400, 900, 600, $$XWSS_APP, 0, 0, 0)
			MoveWindow (WinXAddButton (#winConnGraph, "All synaptic strengths", 0, $$M_SYNSTR), 2, 2, 110, 20, $$TRUE)
			MoveWindow (WinXAddButton (#winConnGraph, "Norm pre", 0, $$M_NORMPRE), 112, 2, 60, 20, $$TRUE)
			MoveWindow (WinXAddButton (#winConnGraph, "Norm post", 0, $$M_NORMPOST), 174, 2, 60, 20, $$TRUE)
			MoveWindow (WinXAddButton (#winConnGraph, "All correlation strengths", 0, $$M_CONNSTR), 236, 2, 120, 20, $$TRUE)
			MoveWindow (WinXAddButton (#winConnGraph, "All common cells", 0, $$M_COMMCELLS), 358, 2, 90, 20, $$TRUE)
			MoveWindow (WinXAddButton (#winConnGraph, "Conn/distance", 0, $$M_CONNDIST), 450, 2, 80, 20, $$TRUE)
			MoveWindow (WinXAddButton (#winConnGraph, "EPSP/orient diff", 0, $$M_EPSPORIENT), 532, 2, 90, 20, $$TRUE)
			MoveWindow (WinXAddButton (#winConnGraph, "Param dev/syn loc", 0, $$M_PARAMSYN), 624, 2, 100, 20, $$TRUE)
			MoveWindow (WinXAddButton (#winConnGraph, "presyn p-d/s-l", 0, $$M_PREPARAMSYN), 726, 2, 80, 20, $$TRUE)
			WinXRegOnCommand (#winConnGraph, &onCommand())
			WinXDisplay (#winConnGraph)

		CASE $$M_DYN
			
			window_width = 850
			window_height = 850

			IF (glfwInit() != $$GL_TRUE) THEN Shut_Down(1)
			
			' 800 x 800, 16 bit color, no depth, alpha or stencil buffers, windowed
			IF (glfwOpenWindow (window_width, window_height, 5, 6, 5, 0, 16, 0, $$GLFW_WINDOW) != $$GL_TRUE) THEN
				Shut_Down (1)
			END IF
			glfwSetWindowTitle (&"Dynamics graphics")
		
			' set the projection matrix to a normal frustum with a max depth of 150
			glMatrixMode ($$GL_PROJECTION)
			glLoadIdentity ()
			aspect_ratio = window_height / DOUBLE(window_width)
			glFrustum (.5, -.5, -.5 * aspect_ratio, .5 * aspect_ratio, 1, 150)
			glMatrixMode ($$GL_MODELVIEW)

			glClear ($$GL_COLOR_BUFFER_BIT | $$GL_DEPTH_BUFFER_BIT)		
			' reset view matrix
			glLoadIdentity ()	
			' move view back
			glTranslatef (0, 0, -142)
			glClearColor(1, 1, 1, 0.0)

			#winDyn = WinXNewWindow (0, "Dynamics control", 1000, 50, 600, 50, $$XWSS_APP, 0, 0, 0)
			MoveWindow (WinXAddButton (#winDyn, "Init + Run", 0, $$M_STARTDYN), 2, 2, 60, 20, $$TRUE)

			#comboDyn = WinXAddComboBox (#winDyn, 120, $$TRUE, 0, $$M_COMBODYN)
			MoveWindow (#comboDyn, 62, 2, 100, 20, $$TRUE)	
			WinXComboBox_AddItem (#comboDyn, -1, 0, "ffCondMult!", 0, 0)
			WinXComboBox_AddItem (#comboDyn, -1, 0, "gEps#", 0, 0)	
			WinXComboBox_AddItem (#comboDyn, -1, 0, "gIps#", 0, 0)
			WinXComboBox_AddItem (#comboDyn, -1, 0, "fbCondMult!", 0, 0)
			WinXComboBox_AddItem (#comboDyn, -1, 0, "endTime", 0, 0)
			WinXComboBox_AddItem (#comboDyn, -1, 0, "bkCondMult!", 0, 0)
			WinXComboBox_AddItem (#comboDyn, -1, 0, "vAhp", 0, 0)
			WinXComboBox_AddItem (#comboDyn, -1, 0, "cellNoise!", 0, 0)
			WinXComboBox_AddItem (#comboDyn, -1, 0, "stimNoise!", 0, 0)


			MoveWindow (WinXAddButton (#winDyn, "ENTER", 0, $$M_CHANGEDYN), 164, 2, 50, 20, $$TRUE)
			MoveWindow (WinXAddButton (#winDyn, "Rerun", 0, $$M_RERUNDYN), 214, 2, 40, 20, $$TRUE)
			MoveWindow (WinXAddButton (#winDyn, "Parameters", 0, $$M_VARDYN), 254, 2, 60, 20, $$TRUE)
			MoveWindow (WinXAddButton (#winDyn, "Display type", 0, $$M_DISPDYN), 316, 2, 70, 20, $$TRUE)
			MoveWindow (WinXAddButton (#winDyn, "Total spikes", 0, $$M_TOTDYN), 388, 2, 70, 20, $$TRUE)
			MoveWindow (WinXAddButton (#winDyn, "Resp/orient", 0, $$M_RODYN), 460, 2, 60, 20, $$TRUE)
			WinXRegOnCommand (#winDyn, &onCommand())
			WinXDisplay (#winDyn)
'			#winDynGraph = WinXNewWindow (0, "Dynamics Graphs", 20, 400, 900, 500, $$XWSS_APP, 0, 0, 0)
'			WinXRegOnCommand (#winDynGraph, &onCommand())
'			WinXDisplay (#winDynGraph)

		CASE $$M_RODYN

			Graphics ($$M_RODYN)

		CASE $$M_TOTDYN

			glLoadIdentity ()
			
			glTranslatef (0, 0, -142)

			PRINT "maxSp! =",maxSp!

			FOR x = 0 TO 141
				FOR y = 0 TO 141

					xx = 71 - x
					yy = 71 - y
		
					relSp! = spikeCount[x,y]/maxSp!

					SELECT CASE TRUE
			
						CASE relSp! = 0
							glColor3b (0, 0, 0)
						CASE relSp! < 0.1
							glColor3b (0, 0, 127)
						CASE relSp! < 0.2
							glColor3b (0, 40, 127)
						CASE relSp! < 0.3
							glColor3b (0, 80, 127)
						CASE relSp! < 0.4
							glColor3b (0, 127, 90)
						CASE relSp! < 0.5
							glColor3b (9, 127, 0)
						CASE relSp! < 0.6
							glColor3b (65, 127, 0)
						CASE relSp! < 0.7
							glColor3b (120, 127, 0)
						CASE relSp! < 0.8
							glColor3b (127, 90, 0)
						CASE relSp! < 0.9
							glColor3b (127, 50, 0)
						CASE relSp! < 1.0
							glColor3b (127, 10, 0)
						CASE relSp! >= 1
							glColor3b (127, 127, 127)
	
					END SELECT
		
					glRecti(xx-1,yy-1,xx,yy)
			
				NEXT y
			NEXT x

			glfwSwapBuffers ()

		CASE $$M_DISPDYN

			glClear ($$GL_COLOR_BUFFER_BIT | $$GL_DEPTH_BUFFER_BIT)
			' reset view matrix
			glLoadIdentity ()	
			' move view back
			glTranslatef (0, 0, -142)
			' swap back and front buffers
			glfwSwapBuffers ()
			glClear ($$GL_COLOR_BUFFER_BIT | $$GL_DEPTH_BUFFER_BIT)
			' reset view matrix
			glLoadIdentity ()	
			' move view back
			glTranslatef (0, 0, -142)
			' swap back and front buffers
			glfwSwapBuffers ()

			SELECT CASE TRUE

				CASE toggle = 0
					toggle = 1
					PRINT "Vm display"
			
				CASE toggle = 1
					toggle = 2
					PRINT "No graphics"

				CASE toggle = 2
					toggle = 0
					PRINT "Cells Display"

			END SELECT

		CASE $$M_VARDYN

			PRINT "ffCondMult! = ",ffCondMult!
			PRINT "gEps# = ",gEps#
			PRINT "gIps# = ",gIps#
			PRINT "fbCondMult! = ",fbCondMult!
			PRINT "endTime = ",endTime
			PRINT "bkCondMult! = ",bkCondMult!
			PRINT "vAhp = ",vAhp
			PRINT "cellNoise! = ",cellNoise!
			PRINT "stimNoise! = ",stimNoise!

		CASE $$M_CHANGESTIM

			IF (listSelect = 0) THEN 

				PRINT "old orOffset! =",orOffset!

				orOffset! = (SINGLE (WinXComboBox_GetEditText$(#comboStim))) / 180

				PRINT "new orOffset! =",orOffset!

				PRINT

				Stimulus ($$C_SECOND)

				Graphics ($$M_2CLOSEST)

			END IF

		CASE $$M_CHANGEDYN

			IF (listSelect = 0) THEN 

				PRINT "old ffCondMult! =",ffCondMult!

				ffCondMult! = SINGLE (WinXComboBox_GetEditText$(#comboDyn))

				PRINT "new ffCondMult! =",ffCondMult!

			END IF

			IF (listSelect = 1) THEN 

				PRINT "old gEps# =",gEps#

				gEps# = SINGLE (WinXComboBox_GetEditText$(#comboDyn))

				PRINT "new gEps# =",gEps#

			END IF

			IF (listSelect = 2) THEN 

				PRINT "old gIps# =",gIps#

				gIps# = SINGLE (WinXComboBox_GetEditText$(#comboDyn))

				PRINT "new gIps# =",gIps#

			END IF

			IF (listSelect = 3) THEN 

				PRINT "old fbCondMult! =",fbCondMult!

				fbCondMult! = SINGLE (WinXComboBox_GetEditText$(#comboDyn))

				PRINT "new fbCondMult! =",fbCondMult!

			END IF

			IF (listSelect = 4) THEN 

				PRINT "old endTime =",endTime

				endTime = XLONG (WinXComboBox_GetEditText$(#comboDyn))

				PRINT "new endTime =",endTime

			END IF

			IF (listSelect = 5) THEN 

				PRINT "old bkCondMult! =",bkCondMult!

				bkCondMult! = SINGLE (WinXComboBox_GetEditText$(#comboDyn))

				PRINT "new bkCondMult! =",bkCondMult!

			END IF

			IF (listSelect = 6) THEN 

				PRINT "old vAhp =",vAhp

				vAhp = XLONG (WinXComboBox_GetEditText$(#comboDyn))

				PRINT "new vAhp =",vAhp

			END IF

			IF (listSelect = 7) THEN 

				PRINT "old cellNoise! =",cellNoise!

				cellNoise! = SINGLE (WinXComboBox_GetEditText$(#comboDyn))

				PRINT "new cellNoise! =",cellNoise!

			END IF

			IF (listSelect = 8) THEN 

				PRINT "old stimNoise! =",stimNoise!

				stimNoise! = SINGLE (WinXComboBox_GetEditText$(#comboDyn))

				PRINT "new stimNoise! =",stimNoise!

			END IF

		CASE $$M_RERUNDYN

			CellDynamics ()

		CASE $$M_STARTDYN

			InitDynamics ()

			CellDynamics ()

		CASE $$M_NORMPRE

			Graphics ($$M_NORMPRE)

		CASE $$M_NORMPOST

			Graphics ($$M_NORMPOST)

		CASE $$M_PARAMSYN

			Graphics ($$M_PARAMSYN)

		CASE $$M_PREPARAMSYN

			Graphics ($$M_PREPARAMSYN)

		CASE $$M_EPSPORIENT

			Graphics ($$M_EPSPORIENT)

		CASE $$M_CONNDIST

			DIM cellsAtDist[10]
			lastArea = 0

			FOR x! = 1 TO 10

				r! = maxPhysDist! * x!/10

				area = ROUNDNE( $$PI * r! * r! )

				ind = x!-1

				cellsAtDist[ind] = area - lastArea

				lastArea = area

			NEXT x!

			Graphics ($$M_CONNDIST)

		CASE $$M_COMMCELLS

			Graphics ($$M_COMMCELLS)

		CASE $$M_CONNSTR

			Graphics ($$M_CONNSTR)

		CASE $$M_SYNSTR

			Graphics ($$M_SYNSTR)

		CASE $$M_STIMDISTANCES

			#winStimDistances = WinXNewWindow (0, "Distances between cells prefered stimuli", - 1, -1, 800, 900, $$XWSS_APP, 0, 0, 0)
			WinXDisplay (#winStimDistances)

			Graphics ($$M_STIMDISTANCES)

		CASE $$M_COMBOCONN
			
			SELECT CASE code

				CASE $$CBN_SELCHANGE

					listSelect = WinXComboBox_GetSelection (hWnd)
					
			END SELECT
			
		CASE $$M_COMBODYN
			
			SELECT CASE code

				CASE $$CBN_SELCHANGE

					listSelect = WinXComboBox_GetSelection (hWnd)
					
			END SELECT

		CASE $$M_COMBOSTIM
			
			SELECT CASE code

				CASE $$CBN_SELCHANGE

					listSelect = WinXComboBox_GetSelection (hWnd)
					
			END SELECT

		CASE $$M_WRITECONN
			
			ConnectCells ($$M_WRITECONN)

			showx = 71
			showy = 71

			Graphics ($$M_SHOWCONN)
			
		CASE $$M_READCONN
			
			ConnectCells ($$M_READCONN)

			showx = 71
			showy = 71

			IFF (NAff) THEN Graphics ($$M_SHOWCONN)
'			Graphics ($$M_SHOWCONN)
			
		CASE $$M_DISPLAYPRECORR
			
			IF (listSelect = 0) THEN showx = XLONG (WinXComboBox_GetEditText$(#comboConn))
			IF (listSelect = 1) THEN showy = XLONG (WinXComboBox_GetEditText$(#comboConn))

			Graphics ($$M_SHOWPRECORR)

		CASE $$M_DISPLAYCORR
			
'			PRINT "selection is",listSelect
			
'			IF (listSelectCorr = 0) THEN showx = XLONG (WinXComboBox_GetEditText$(#comboCorr))
'			IF (listSelectCorr = 1) THEN showy = XLONG (WinXComboBox_GetEditText$(#comboCorr))
			IF (listSelect = 0) THEN showx = XLONG (WinXComboBox_GetEditText$(#comboConn))
			IF (listSelect = 1) THEN showy = XLONG (WinXComboBox_GetEditText$(#comboConn))

			Graphics ($$M_SHOWCORR)
			
		CASE $$M_DISPLAYCONN
			
'			PRINT "selection is",listSelect
			
			IF (listSelect = 0) THEN showx = XLONG (WinXComboBox_GetEditText$(#comboConn))
			IF (listSelect = 1) THEN showy = XLONG (WinXComboBox_GetEditText$(#comboConn))

			Graphics ($$M_SHOWCONN)
			
		CASE $$M_DISPLAYPRECONN

			IF (listSelect = 0) THEN showx = XLONG (WinXComboBox_GetEditText$(#comboConn))
			IF (listSelect = 1) THEN showy = XLONG (WinXComboBox_GetEditText$(#comboConn))

			Graphics ($$M_DISPLAYPRECONN)

		CASE $$M_2CLOSEST
			
'			PRINT "orOffset! sent = ",orOffset!
			
			Stimulus ($$C_SECOND)
			
			Graphics ($$M_2CLOSEST)
				
		CASE $$M_CLOSEST

			Graphics ($$M_CLOSEST)

		CASE $$M_OR
			
			Graphics ($$M_OR)

		CASE $$M_SPFQ
			
			Graphics ($$M_SPFQ)

		CASE $$M_RND
			
			Graphics ($$M_RND)
		
		CASE $$M_P4
			
			Graphics ($$M_P4)

		CASE $$M_CLEARATT
			
			#clearWin = #winAtt
			
			Graphics ($$M_CLEAR)
			
		CASE $$M_CLEARCONN
			
			#clearWin = #winConn
		
			Graphics ($$M_CLEAR)
			
		CASE $$M_CLEARSTIM
			
			#clearWin = #winStim
		
			Graphics ($$M_CLEAR)

	END SELECT

END FUNCTION
	
FUNCTION StartSim (id)

	SHARED distFile0$
	SHARED distFile1$

SELECT CASE id
	
	CASE $$M_STARTRAT

		AssignAttributes ($$M_STARTRAT)

		'Euclidean distances from cell attributes to stim
		distFile0$ = "DistancesR0.dat"
		distFile1$ = "DistancesR1.dat"

		PRINT "Rat Attributes assigned"

	CASE $$M_STARTCAT

		AssignAttributes ($$M_STARTCAT)

		'Euclidean distances from cell attributes to stim
		distFile0$ = "DistancesC0.dat"
		distFile1$ = "DistancesC1.dat"

		PRINT "Cat Attributes assigned"

END SELECT
	
END FUNCTION

FUNCTION Shut_Down (return_code)

	IF #winStimDistances THEN ret = DestroyWindow (#winStimDistances) ' destroy window #winStimDistances
	#winStimDistances = 0

	IF #winDynGraph THEN ret = DestroyWindow (#winDynGraph) ' destroy window #winDynGraph
	#winDynGraph = 0

	IF #winDyn THEN	ret = DestroyWindow (#winDyn) ' destroy window #winDyn
	#winDyn = 0

	IF #winConnGraph THEN	ret = DestroyWindow (#winConnGraph) ' destroy window #winConnGraph
	#winConnGraph = 0

	IF #winConn THEN ret = DestroyWindow (#winConn) ' destroy window #winConn
	#winConn = 0

	IF #winStim THEN ret = DestroyWindow (#winStim) ' destroy window #winStim
	#winStim = 0

	IF #winAtt THEN	ret = DestroyWindow (#winAtt) ' destroy window #winAtt
	#winAtt = 0

	IF #winMain THEN ret = DestroyWindow (#winMain) ' destroy window #winMain
	#winMain = 0

	glfwTerminate ()
	QUIT (return_code)

END FUNCTION

FUNCTION  InitDynamics ()

SHARED rat
SHARED gIps#
SHARED ffCondMult!
SHARED fbCondMult!
SHARED gEps#
SHARED synNum
SHARED maxStr!
SHARED connStr![]
SHARED adjustFaliures
SHARED cellNum
SHARED maxDist! 
SHARED vRest 
SHARED vAhp 
SHARED vThresh 
SHARED eRev 
SHARED iRev 
SHARED spikeLength 
SHARED tau 
SHARED recipTau! 
SHARED rm 
SHARED rm1 
SHARED rm2 
SHARED ra1! 
SHARED ra2! 
SHARED recipRa1! 
SHARED recipRa2! 
SHARED dt 
SHARED dtTau! 
SHARED endTime 
SHARED iDelay 
SHARED eDelay 
SHARED epscLength 
SHARED ipscLength 
SHARED bkCondMult!
'SHARED randInputCond!
SHARED connOn
SHARED singleEPSP
SHARED cellNoise!
SHARED stimNoise!

IF (adjustFaliures) THEN

PRINT "Adjusting EPSP amplitudes for faliures"

	FOR x = 0 TO 141
		FOR y = 0 TO 141
			FOR k = 0 TO synNum-1
	
				ratio! = connStr![x,y,k]/maxStr!
		
				IF ratio! < 0.2 THEN connStr![x,y,k] = connStr![x,y,k] * ratio! * 5
'				IF (ratio! > 0.2) AND (ratio! < 0.4) THEN connStr![x,y,k] = connStr![x,y,k] * (ratio! - 0.2) * 5							'	for testing effect of failures
	
				IF connStr![x,y,k] < 0 THEN connStr![x,y,k] = 0

				adjustFaliures = 0
	
			NEXT k
		NEXT y
	NEXT x

END IF

bursting = 0							' flag for burst firing on
singleEPSP = 0						' flag for single EPSP from 71,71 to 72,72 on at time = 3ms
connOn = 1								' flag for synaptic conductances on
ffCondMult! = 15					' low value
'ffCondMult! = 30					' high value
fbCondMult! = 1
gEps# = 5d-7							' mS
'gEps# = 5d-7 * 2					' multiply when using synNum = 500
'gEps# = 5d-7 * 1.5				' multiply when using randPoisson
bkCondMult! = 8						' not used

IF (connOn) THEN

'	gIps# = 1d-8 * 2				' multiply when using synNum = 500
	gIps# = 1d-8						' regular
'	gIps# = 5d-9						' regular  later testing

ELSE

	gIps# = 0

END IF

IF (bursting) THEN

	gIps# = 6d-8
	vAhp = -52

ELSE

	vAhp = -70

END IF


cellNum = 20163
maxDist! = 2.0						' Largest diff possible between params

vRest = -60
vThresh = -50
eRev = 0
iRev = -60
spikeLength = 100
tau = 2000
recipTau! = 0.0005
rm = 100000								' k ohm
rm1 = 250000
rm2 = 300000
ra1! = 4000
ra2! = 4000
recipRa1! = 1/ra1!
recipRa2! = 1/ra2!
dt = 1										' everything scaled to units of 10us
dtTau! = 0.0005
endTime = 20000
iDelay = 250
eDelay = 130
epscLength = 50
ipscLength = 200
'randInputCond! = 15
cellNoise! = 10						' for gEps# = 5d-7 this is 5nS for each eNoise[]
stimNoise! = 3

END FUNCTION
'
' #############################
' #####  CellDynamics ()  #####
' #############################
'
FUNCTION  CellDynamics ()

SHARED pyrsAttributes![]
SHARED connMatrix@@[]
SHARED connStr![]
SHARED gIps#
SHARED ffCondMult!
SHARED fbCondMult!
SHARED gEps#
SHARED v![]
SHARED v1![]
SHARED v2![]
SHARED vSpike[]
SHARED spike[]
SHARED spikePointer[]
SHARED iSpike[]
SHARED spikeCount[]
SHARED iSpikePointer[]
SHARED gE![]
SHARED spikeFile$
SHARED synNum
SHARED maxStr!
SHARED distFile1$
SHARED cellNum
SHARED maxDist! 
SHARED vRest 
SHARED vAhp 
SHARED vThresh 
SHARED eRev 
SHARED iRev 
SHARED gI	
SHARED spikeLength 
SHARED tau 
SHARED recipTau! 
SHARED rm 
SHARED rm1 
SHARED rm2 
SHARED ra1! 
SHARED ra2! 
SHARED recipRa1! 
SHARED recipRa2! 
SHARED dt 
SHARED dtTau! 
SHARED endTime 
SHARED time 
SHARED totSpikes 
SHARED iDelay 
SHARED eDelay 
SHARED epscLength 
SHARED ipscLength 
'SHARED randInputCond!
SHARED showx
SHARED showy
SHARED #clearWin
SHARED allSpikes
SHARED toggle
SHARED maxSp!
SHARED bkCondMult!
SHARED orOffset!
SHARED rat
SHARED connOn
SHARED singleEPSP
SHARED cellNoise!
SHARED stimNoise!

DIM v![142,142]
DIM v1![142,142]
DIM v2![142,142]
DIM vSpike[142,142]
DIM spike[142,142,10]
DIM spikePointer[142,142]
DIM gE![142,142]
DIM iSpike[142,142,10]
DIM iSpikePointer[142,142]
DIM spikeCount[142,142]
DIM eNoise[142,142]
DIM iNoise[142,142]

IFF (connOn) THEN

	DIM connMatrix@@[2,142,142,synNum]
	DIM connStr![142,142,synNum]

END IF

IF (singleEPSP) THEN
	connMatrix@@[0,71,71,0] = 72
	connMatrix@@[1,71,71,0] = 72
	connStr![71,71,0] = 2
	synNum = 5
END IF

IF (rat) THEN 
	spikeFile$ = "SpikesR_" + STRING(SLONG(orOffset!*180))
ELSE
	spikeFile$ = "SpikesC_" + STRING(SLONG(orOffset!*180))
END IF

noise = 0											' flag to add random cond noise to all cells
inputNoise = 0								' flag to add random cond noise to all inputs
time = 0
totSpikes = 0
gI	= 0												' number of I spikes in queue
allSpikes = 0
maxSp! = 0

FOR x = 0 TO 141
	FOR y = 0 TO 141

'		add! = XstRandomRangeF (0,9)
		add! = 0

		v![x,y] = vRest + add!
		v1![x,y] = vRest + add!
		v2![x,y] = vRest + add!

	NEXT y
NEXT x

PRINT "Starting dynamics..."

'GOSUB RandomInput
GOSUB TuningBasedInput								' must call before any other mod to g[x,y]

IF (noise)														' initialise nonspecific noise, otherwise takes 30ms to reach steady state - can comment out to generate figs, v. little effect on results

	FOR en = 1 TO 8000									' steady state eNoise, counter greater than 6700 to compensate for duplication in assignment
	
		x = XstRandomRange(0,141)
		y = XstRandomRange(0,141)
		eNoise[x,y] = cellNoise!

	NEXT en

	FOR in = 1 TO 21000									' steady state iNoise, counter greater than 13400 to compensate for duplication in assignment
	
		x = XstRandomRange(0,141)
		y = XstRandomRange(0,141)
		iNoise[x,y] = cellNoise!

	NEXT in

END IF


DO WHILE NOT (time > endTime)

'PRINT "gI =",gI

IF (singleEPSP) THEN
	IF (time > 300) THEN gE![71,71] = 500
	IF ( time >= 360 ) THEN gE![71,71] = 0
END IF

FOR x = 0 TO 141
	FOR y = 0 TO 141

		IF (noise) AND NOT (time MOD 100) THEN		' need to change this if changing dt

' Note because of how gI is now implemtented as number of inhib spikes active, iNoise is equivalent to 10 spikes with cellNoise! = 10, 0.1nS, basically irrelavant. So all 
' nonspecific noise is effectively only excitatory, same as specific noise.
	
			IF (XstRandomUniform() < 0.0005) THEN 
	
'PRINT x,y, "on"

				iNoise[x,y] = 0
				eNoise[x,y] = cellNoise!
	
			END IF
	
			IF (XstRandomUniform() > 0.999) THEN
	
				iNoise[x,y] = cellNoise!
				eNoise[x,y] = 0
	
			END IF
		END IF

'IF (x=72) AND (y=72) THEN

'	PRINT gE![x,y]

'END IF

		iE! = (eNoise[x,y] + gE![x,y]) * gEps# * (eRev - v2![x,y])
'		iE! = gE![x,y] * gEps# * (eRev - v2![x,y])
		ia2! = recipRa2! * ( v1![x,y] - v2![x,y] )
		vInf! = ( vRest - v2![x,y] + ( rm2 * ( ia2! + iE! ) ) )

'IF (time! > 3) AND (time! < 5) AND (x=70) AND (y=70) THEN PRINT "recipRa2! = "recipRa2!
'IF (time! > 3) AND (time! < 5) AND (x=70) AND (y=70) THEN PRINT "iE! = "iE!
'IF (time! > 3) AND (time! < 5) AND (x=70) AND (y=70) THEN PRINT "ia2! = "ia2!
'IF (time! > 3) AND (time! < 5) AND (x=70) AND (y=70) THEN PRINT "vInf! = "vInf!

		k1! = dtTau! * vInf!
		k2! = dtTau! * ( ( k1! * 0.5 ) + vInf! )
		k3! = dtTau! * ( ( k2! * 0.5 ) + vInf! )
		k4! = dtTau! * ( k3! + vInf! )
		v2![x,y] = v2![x,y] + ( k1! + ( 2 * k2! ) + ( 2 * k3! ) + k4! ) * 0.1667

		iI! = (iNoise[x,y] + gI) * gIps# * (iRev - v1![x,y])
'		iI! = gI * gIps# * (iRev - v1![x,y])
		ia1! = recipRa1! * ( v![x,y] - v1![x,y] )
		vInf! = ( vRest - v1![x,y] + ( rm1 * ( ia1! - ia2! + iI! ) ) )

		k1! = dtTau! * vInf!
		k2! = dtTau! * ( ( k1! * 0.5 ) + vInf! )
		k3! = dtTau! * ( ( k2! * 0.5 ) + vInf! )
		k4! = dtTau! * ( k3! + vInf! )
		v1![x,y] = v1![x,y] + ( k1! + ( 2 * k2! ) + ( 2 * k3! ) + k4! ) * 0.1667

		IFZ (vSpike[x,y]) THEN

			iI! = gI * gIps# * (iRev - v![x,y])

			vInf! = ( vRest - v![x,y] + ( rm * ( - ia1! + iI! ) ) )

			k1! = dtTau! * vInf!
			k2! = dtTau! * ( ( k1! * 0.5 ) + vInf! )
			k3! = dtTau! * ( ( k2! * 0.5 ) + vInf! )
			k4! = dtTau! * ( k3! + vInf! )
			v![x,y] = v![x,y] + ( k1! + ( 2 * k2! ) + ( 2 * k3! ) + k4! ) * 0.1667

'			k1! = dt! * (( - v![x,y] + vRest + (rm * (iE! + iI! ))) * recipTau!)
'			k2! = dt! * (( (k1! * 0.5) - v![x,y] + vRest + (rm * (iE! + iI! ))) * recipTau!)
'			k3! = dt! * (( (k2! * 0.5) - v![x,y] + vRest + (rm * (iE! + iI! ))) * recipTau!)
'			k4! = dt! * (( k3! - v![x,y] + vRest + (rm * (iE! + iI! ))) * recipTau!)
'			v![x,y] = v![x,y] + ( k1! + ( 2 * k2! ) + ( 2 * k3! ) + k4! ) * 0.1667

			IF (v![x,y] > vThresh) THEN

'PRINT "spike"x,y

				v![x,y] = -40 					'average vm of spike
				vSpike[x,y] = time
				spike[x,y,spikePointer[x,y]] = time
				iSpike[x,y,iSpikePointer[x,y]] = time
				INC spikePointer[x,y]
				INC iSpikePointer[x,y]
				INC spikeCount[x,y]
				INC totSpikes

'PRINT "spike set"x,y

			END IF
		END IF

		IF ( ( vSpike[x,y] ) AND ( vSpike[x,y] = ( time - spikeLength ) ) ) THEN

'PRINT "spike end"x,y

			v![x,y] = vAhp
			v1![x,y] = vAhp
			vSpike[x,y] = 0
			DEC totSpikes

		END IF

		IF (spikePointer[x,y]) THEN

'PRINT "eConn"x,y

			eDL = time - eDelay
			eST = eDL - epscLength
	
			FOR j = 0 TO spikePointer[x,y]-1
	
				IF spike[x,y,j] = eDL THEN

'PRINT "INC gE"x,y

					FOR k = 0 TO synNum-1
	
						xx = connMatrix@@[0,x,y,k]
						yy = connMatrix@@[1,x,y,k]
	
						gE![xx,yy] = gE![xx,yy] + (connStr![x,y,k] * fbCondMult!)

					NEXT k
	
				END IF
	
				IF spike[x,y,j] = eST THEN 
	
'PRINT "DEC gE"x,y

					FOR k = 0 TO synNum-1
	
						xx = connMatrix@@[0,x,y,k]
						yy = connMatrix@@[1,x,y,k]
	
						gE![xx,yy] = gE![xx,yy] - (connStr![x,y,k] * fbCondMult!)
	
						IF (gE![xx,yy] < 0) THEN gE![xx,yy] = 0							'remove rounding errors
	
					NEXT k
	
					FOR k = 0 TO spikePointer[x,y]-1

'PRINT "dec spike"x,y
	
						spike[x,y,k] = spike[x,y,k+1]
	
					NEXT k
	
					DEC spikePointer[x,y]
					DEC j
	
				END IF	
			NEXT j
		END IF

		IF (iSpikePointer[x,y]) THEN

'PRINT "iConn"x,y

			iDL = time - iDelay
			iST = iDL - ipscLength
	
			FOR j = 0 TO iSpikePointer[x,y]-1
	
				IF iSpike[x,y,j] = iDL THEN 

'PRINT "INC gI"x,y

					INC gI

				END IF

				IF iSpike[x,y,j] = iST THEN
	
'PRINT "DEC gI"x,y

					DEC gI
	
IF (gI < 0) THEN
PRINT "gI =",gI,"******************************************"
END IF

					FOR k = 0 TO iSpikePointer[x,y]-1

'PRINT "dec iSpike"x,y

						iSpike[x,y,k] = iSpike[x,y,k+1]

					NEXT k

					DEC iSpikePointer[x,y]
					DEC j
	
				END IF	
			NEXT j
		END IF

	NEXT y
NEXT x

' escape to exit loop
IF (glfwGetKey ($$GLFW_KEY_ESC) == $$GLFW_PRESS) || (glfwGetWindowParam($$GLFW_OPENED) = 0) THEN EXIT DO

IFF toggle = 2 THEN

'PRINT "setting up GL"

'	glClear ($$GL_COLOR_BUFFER_BIT | $$GL_DEPTH_BUFFER_BIT)
		
	' reset view matrix
	glLoadIdentity ()
	
	' move view back
	glTranslatef (0, 0, -142)

END IF

IF toggle = 0 THEN

	FOR x = 0 TO 141
		FOR y = 0 TO 141
	
				xx = 71 - x
				yy = 71 - y
	
					SELECT CASE TRUE
			
						CASE v![x,y] < -65
							glColor3b (0, 0, 0)
						CASE v![x,y] < -60
							glColor3b (0, 0, 127)
						CASE v![x,y] < -59
							glColor3b (0, 40, 127)
						CASE v![x,y] < -58
							glColor3b (0, 80, 127)
						CASE v![x,y] < -57
							glColor3b (0, 127, 115)
						CASE v![x,y] < -56
							glColor3b (0, 127, 55)
						CASE v![x,y] < -55
							glColor3b (9, 127, 0)
						CASE v![x,y] < -54
							glColor3b (65, 127, 0)
						CASE v![x,y] < -53
							glColor3b (125, 127, 0)
						CASE v![x,y] < -52
							glColor3b (127, 90, 0)
						CASE v![x,y] < -51
							glColor3b (127, 50, 0)
						CASE v![x,y] < -50
							glColor3b (127, 10, 0)
						CASE v![x,y] >= -50
							glColor3b (127, 127, 127)
	
					END SELECT
	
	'    glColor3b (red, green, blue)
	'   glColor3b (XstRandomRange(0,127), XstRandomRange(0,127), XstRandomRange(0,127))
	'     glRectd(-70,-70,-71,-71)
	
	glRecti(xx-1,yy-1,xx,yy)
	
		NEXT y
	NEXT x

	' swap back and front buffers
	glfwSwapBuffers ()

END IF

IF toggle = 1 THEN

	glfwSwapBuffers ()

	t! = 71 - (time*142.0/endTime)

	glColor3b (0, 0, 0)

	v! = v![72,72] + 30
	v1! = v1![72,72] + 60
	v2! = v2![72,72] + 90

'	glRectf(t!-1,v!-1,t!,v!)
'	glRectf(t!-1,v1!-1,t!,v1!)
'	glRectf(t!-1,v2!-1,t!,v2!)
	glRectf(t!-0.75,v!-0.75,t!-0.25,v!-0.25)
	glRectf(t!-0.75,v1!-0.75,t!-0.25,v1!-0.25)
	glRectf(t!-0.75,v2!-0.75,t!-0.25,v2!-0.25)

'	glBegin($$GL_LINES)
'	glBegin($$GL_POINTS)

'		glVertex3f(t,v!,0)
'		glVertex3f(t,v1!,0)
'		glVertex3f(t,v2!,0)

'		glVertex2f(t-1,vO!)
'		glVertex2f(t,v!)
'		glVertex2f(t-1,v1O!)
'		glVertex2f(t,v1!)
'		glVertex2f(t-1,v2O!)
'		glVertex2f(t,v2!)

'	glEnd()

'	vO! = v!
'	v1O! = v1!
'	v2O! = v2!

	glColor3b (127, 0, 0)

	vPre! = v![71,71]

	glRectf(t!-0.75,vPre!-0.75,t!-0.25,vPre!-0.25)

'	glBegin($$GL_LINES)
'	glBegin($$GL_POINTS)

'		glVertex2f(t-1,vPreO!)
'		glVertex2f(t,vPre!)

'	glEnd()

'	vPreO! = vPre!

	glfwSwapBuffers ()

END IF

PRINT "time, totSpikes, gI = "time,totSpikes,gI

'PRINT "time, totSpikes = "time, totSpikes
'PRINT "time, v![72,72] = "time, v![72,72]
'PRINT "totSpikes = "totSpikes
'PRINT "v![72,72] = "v![72,72]
'PRINT "v1![72,72] = "v1![72,72]
'PRINT "v2![70,70] = "v2![70,70]
'PRINT "gE![71,74] = "gE![71,74]
'PRINT "gI = "gI

' determine steady state nonspecific noise
'ec = 0
'ic = 0

'FOR x = 0 TO 141
'	FOR y = 0 TO 141

'		IF eNoise[x,y] THEN INC ec

'		IF iNoise[x,y] THEN INC ic

'	NEXT y
'NEXT x

'PRINT "ec, ic = "ec,ic

time = time + dt

LOOP		' until endTime

'IF toggle = 1 THEN glfwSwapBuffers ()

FOR x = 0 TO 141
	FOR y = 0 TO 141

		allSpikes = allSpikes + spikeCount[x,y]

		IF spikeCount[x,y] > maxSp! THEN maxSp! = spikeCount[x,y]

	NEXT y
NEXT x

PRINT "allSpikes =",allSpikes

GOSUB WriteSpikes

PRINT "...done\n"

SUB RandomInput								'not really used, cant use with tuning...

	FOR x = 0 TO 141
		FOR y = 0 TO 141

			gE![x,y] = XstRandomRangeF(0,bkCondMult!)

'			gE![x,y] = ffCondMult!

'PRINT "gE![x,y] =",x,y,gE![x,y]

		NEXT y
	NEXT x

END SUB

SUB TuningBasedInput

	file = OPEN(distFile1$,$$RD)

	var! = 0.1
	var2! = 2 * var!
	lhs! = 1 / Sqrt ( var2! * $$PI )

	FOR a = 0 TO cellNum

		READ [file],x,y,d!

		gE![x,y] = gE![x,y] + lhs! * Exp( - ( d! * d! ) / var2! ) * ffCondMult!

'		gE![x,y] = gE![x,y] + 6							'background depolarization to all

		IF (inputNoise) THEN

			IF (XstRandomUniform() < 0.5) THEN

				gE![x,y] = gE![x,y] + (gE![x,y] / stimNoise!)

			ELSE

				gE![x,y] = gE![x,y] - (gE![x,y] / stimNoise!)

			END IF
		END IF

		IF gE![x,y] < 0 THEN

			gE![x,y] = 0

		END IF

	NEXT a

'PRINT "gE![66,77],gE![76,67],gE![86,87],gE![96,97] =",gE![66,77],gE![76,67],gE![86,87],gE![96,97]

	CLOSE(file)

END SUB

SUB WriteSpikes

file = OPEN(spikeFile$,$$WR)

FOR x = 0 TO 141
	FOR y = 0 TO 141

  	a = spikeCount[x,y]

'PRINT "a =",a

  	WRITE [file], a

	NEXT y
NEXT x
CLOSE(file)
END SUB

END FUNCTION


FUNCTION CalcConnect (x,y)

'For each cell find random target cell (not already connected or self) within maxPhysDist that doesn't already have too many presynaptic cells and calculate distance between 
'their attributes, if this distance is lower than threshDist then probalistically connect based on linear fn of this distance and physical distance

SHARED pyrsAttributes![]
SHARED connMatrix@@[]
SHARED connStr![]
SHARED synNum
SHARED maxPhysDist!
SHARED numCommonPre%%[]
SHARED numCommonPost%%[]
SHARED preSynCount[]
SHARED preSynCell@@[]
SHARED cellsProcessed

maxDist! = 2									' Largest diff possible between params
distProbScaling! = 142 * 0.6	' Determines slope of prob conn/distance relation
threshDist! = 1.1							' Max difference between params to establish a conn
c = 0

or1! = pyrsAttributes![0,x,y]
sf1! = pyrsAttributes![1,x,y]
rp1! = pyrsAttributes![2,x,y]
p41! = pyrsAttributes![3,x,y]

DO WHILE ( c < synNum )

	xx = XstRandomRange(0,141)
	yy = XstRandomRange(0,141)

	alreadyConnected = 0

'PRINT "begining"
'PRINT "start c =",c

	IF ( c ) THEN

'IF c = 201 THEN PRINT "e"

'IF c = 201 THEN PRINT connMatrix@@[0,x,y,1]

		FOR z = 0 TO c-1

'IF c = 201 THEN PRINT z,connMatrix@@[0,x,y,z],xx,connMatrix@@[1,x,y,z],yy
'IF c = 201 THEN PRINT z,xx,yy

			IF (connMatrix@@[0,x,y,z] = xx) AND (connMatrix@@[1,x,y,z] = yy) THEN 
				
'IF c = 201 THEN PRINT "f"

				INC alreadyConnected
				EXIT FOR

			END IF

		NEXT z

	END IF

'PRINT "d"

	IFF ( (alreadyConnected) OR ((x=xx) AND (y=yy)) ) THEN

		pd! = CalculatePhyscialDistance (x,y,xx,yy)

'PRINT "((((cellsProcessed+1)/142.0)+1) /142.0) =",(((cellsProcessed+1)/142.0)+1)/142.0
'PRINT "preSynCount[xx,yy] =",preSynCount[xx,yy]

		IFZ (( pd! > maxPhysDist! ) OR ( preSynCount[xx,yy] > ROUNDNE( synNum*1.1 * ( (((cellsProcessed+1)/142.0)+1) /142.0) ))) THEN

'PRINT "c =",c
'PRINT "x,y,xx,yy = "x,y,xx,yy

			or2! = pyrsAttributes![0,xx,yy]
			sf2! = pyrsAttributes![1,xx,yy]
			rp2! = pyrsAttributes![2,xx,yy]
			p42! = pyrsAttributes![3,xx,yy]

			dist! = CalculateCellDistance (or1!,sf1!,rp1!,p41!,or2!,sf2!,rp2!,p42!)

'PRINT "dist!",dist!
'PRINT "pd!",pd!

			IF ((XstRandomUniform() < 1 - pd!/distProbScaling!) AND (dist! < threshDist!) AND (XstRandomUniform() < 1 - dist!/threshDist!) ) THEN

				connMatrix@@[0,x,y,c] = xx
				connMatrix@@[1,x,y,c] = yy

				INC c

'PRINT "b"

				preSynCell@@[0,xx,yy,preSynCount[xx,yy]] = x
				preSynCell@@[1,xx,yy,preSynCount[xx,yy]] = y
				
				IFF ( preSynCount[xx,yy] < synNum*1.15 ) THEN PRINT "Too many presynaptic cells!"

				INC preSynCount[xx,yy]

'PRINT "x,y,xx,yy = "x,y,xx,yy

			END IF
'PRINT "c"
		END IF
	END IF
LOOP

END FUNCTION

'
'
' #############################
' #####  ConnectCells ()  #####
' #############################
'
FUNCTION  ConnectCells (id)

SHARED pyrsAttributes![]
SHARED connMatrix@@[]
SHARED connStr![]
SHARED synNum
SHARED maxPhysDist!
SHARED rat
SHARED numCommonPre%%[]
SHARED numCommonPost%%[]
SHARED preSynCount[]
SHARED preSynCell@@[]
SHARED cellsProcessed
SHARED maxStr!
SHARED postCC![]
SHARED commFile$
SHARED recipAmp! []
SHARED numRecip
SHARED adjustFaliures
SHARED meanDist![]
SHARED NAff

adjustFaliures = 1						' Adjustment of EPSP amplitudes for mean failures in InitDynamics() on
synNum = 1000
'synNum = 500
maxPhysDist! = 142 * 0.5			' 350um axonal arbor radius + 150um basal dendrite length - any cell can reach half of all cells using 0.4, 78.5% using 0.5
NAff = 0											' flag for NeighborAffinity sub

IF (rat) THEN 
	shuffledConnFile$ = "shuffledConnR"
	randConnFile$ = "randPoissonConnR"
	connFile$ = "connR1000"
	commFile$ = "RnumCommon1000"
	preconnFile$ = "preconnR1000"
ELSE
	shuffledConnFile$ = "shuffledConnC"
	randConnFile$ = "randPoissonConnC"
	connFile$ = "connC1000"
	commFile$ = "CnumCommon1000"
	preconnFile$ = "preconnC1000"
END IF

PRINT connFile$

DIM connMatrix@@[2,142,142,synNum]							' Max 255
DIM numCommonPost%%[142,142,synNum]
DIM numCommonPre%%[142,142,synNum]
DIM connStr![142,142,synNum]
DIM preSynCount[142,142]
DIM preSynCell@@[2,142,142,synNum*1.2]					' Max 255
DIM cellTaken[142,142]
DIM postCC![142,142]
DIM preCC![142,142]


SELECT CASE id
	
	CASE $$M_WRITECONN

		GOSUB CellConn
		GOSUB WriteConns

	CASE $$M_READCONN

		GOSUB ReadConns
'		GOSUB RedoConnns
'		GOSUB CountRecip
'		GOSUB PathLength
'		GOSUB NeighborAffinity
'		GOSUB OrientConnProb
'		GOSUB RandPoissonConns										' using this will make new poisson conns, save existing first
'		GOSUB ReadPoissonConns
'		GOSUB ShuffleSynAmps
'		GOSUB ReadShuffledConns
		
END SELECT

SUB CellConn

PRINT "Calculating cell connections..."

cellsProcessed = 0

DO WHILE ( cellsProcessed < 142*142*0.95 )

	x = XstRandomRange(0,141)
	y = XstRandomRange(0,141)

	IFZ ( cellTaken[x,y] ) THEN

		CalcConnect (x,y)

		INC cellTaken[x,y]
		INC cellsProcessed
	
'PRINT "1 cellsProcessed =",cellsProcessed

'	ELSE PRINT "taken"

	END IF

LOOP

PRINT "Last few cells..."

FOR x = 0 TO 141
	FOR y = 0 TO 141

		IFZ ( cellTaken[x,y] ) THEN

			CalcConnect (x,y)
	
			INC cellTaken[x,y]
			INC cellsProcessed
	
'PRINT "2 cellsProcessed =",cellsProcessed

'		ELSE PRINT "taken"

		END IF

	NEXT y
PRINT "x = "x
NEXT x

totalPreSyn = 0
maxPreSyn = 0
avPreSyn = 0

FOR x = 0 TO 141
	FOR y = 0 TO 141

		totalPreSyn = totalPreSyn + preSynCount[x,y]
		
		IF ( preSynCount[x,y] > maxPreSyn ) THEN maxPreSyn = preSynCount[x,y]

	NEXT y
NEXT x

avPreSyn = totalPreSyn/(142.0*142.0)

PRINT "totalPreSyn =",totalPreSyn
PRINT "maxPreSyn =",maxPreSyn
PRINT "avPreSyn =",avPreSyn

'calculate number of shared targets, inputs
'Assign synaptic strength proportional to clustering
PRINT "Calculating synaptic strengths..."
maxPost! = 0
maxPre! = 0
maxPostCC! = 0
maxPreCC! = 0
maxStr! = 0

FOR x = 0 TO 141
	FOR y = 0 TO 141
		FOR z = 0 TO synNum-1

			xNew = connMatrix@@[0,x,y,z]
			yNew = connMatrix@@[1,x,y,z]

			IF ( z ) THEN  

				FOR a = 0 TO z-1
	
					xOld = connMatrix@@[0,x,y,a]
					yOld = connMatrix@@[1,x,y,a]
		
					FOR b = 0 TO synNum-1
		
						IF ((xNew = connMatrix@@[0,xOld,yOld,b]) AND (yNew = connMatrix@@[1,xOld,yOld,b])) THEN INC numCommonPost%%[x,y,z]
						IF ((xOld = connMatrix@@[0,xNew,yNew,b]) AND (yOld = connMatrix@@[1,xNew,yNew,b])) THEN INC numCommonPost%%[x,y,a]	
	
					NEXT b
				NEXT a
			END IF

			FOR a = 0 TO preSynCount[x,y]-1
				FOR b = 0 TO preSynCount[xNew,yNew]-1

'					IFF ((preSynCells[x1,y1,b,0] = x) AND (preSynCells[x1,y1,b,1] = y)) OR ((preSynCells[x,y,a,0] = x1) AND (preSynCells[x1,y1,a,1] = y1)) THEN

					IF ((preSynCell@@[0,xNew,yNew,b] = preSynCell@@[0,x,y,a]) AND (preSynCell@@[1,xNew,yNew,b] = preSynCell@@[1,x,y,a])) THEN 

						INC numCommonPre%%[x,y,z]
						EXIT FOR

					END IF

				NEXT b
			NEXT a
		NEXT z
	NEXT y
PRINT "x = "x
NEXT x

'Matrix method for counting common neighbors - currently broken

'cellNum = 20163									' one less than # of cells

'DIM M@@[cellNum,cellNum]

'FOR x = 0 TO 141
'	FOR y = 0 TO 141
'		FOR z = 0 TO synNum-1 

'			xx = connMatrix@@[0,x,y,z]
'			yy = connMatrix@@[1,x,y,z]

'			pre = x * 142 + y
'			post = xx * 142 + yy

'			INC M@@[pre,post]

'		NEXT z
'	NEXT y
''PRINT x
'NEXT x

'PRINT "made M"
'PRINT "counting postsyn common neighbors..."

'FOR row = 0 TO cellNum
'	FOR col = 0 TO cellNum

''		IF (col > row) AND ((M@@[row,col]) OR (M@@[col,row])) THEN
'		IF (col != row) AND (M@@[row,col]) THEN

'			count = 0

'			FOR x = 0 TO cellNum

'				IF (M@@[row,x] AND M@@[col,x]) THEN INC count

'			NEXT x

'			prex = row/142 
'			prey = row MOD 142
'			postx = col/142 
'			posty = col MOD 142

''			IF (M@@[row,col]) THEN

'				FOR z = 0 TO synNum-1
	
'					IF (connMatrix@@[0,prex,prey,z] = postx) AND (connMatrix@@[1,prex,prey,z] = posty) THEN
	
'						numCommonPost%%[prex,prey,z] = count
	
'						EXIT FOR
	
'					END IF	
'				NEXT z
''			END IF

''			IF (M@@[col,row]) THEN

''				FOR z = 0 TO synNum-1
	
''					IF (connMatrix@@[0,postx,posty,z] = prex) AND (connMatrix@@[1,postx,posty,z] = prey) THEN
	
''						numCommonPost%%[postx,posty,z] = count
	
''						EXIT FOR
	
''					END IF	
''				NEXT z
''			END IF

'		END IF
'	NEXT col
''PRINT row
'NEXT row
	
''new presyn

'DIM M@@[cellNum,cellNum]

'FOR x = 0 TO 141
'	FOR y = 0 TO 141
'		FOR k = 0 TO preSynCount[x,y]-1

'			xx = preSynCell@@[0,x,y,k]
'			yy = preSynCell@@[1,x,y,k]

'			pre = x * 142 + y
'			post = xx * 142 + yy

'			INC M@@[pre,post]

'		NEXT k
'	NEXT y
''PRINT x
'NEXT x

'PRINT "made M"
'PRINT "counting presyn common neighbors..."

'FOR row = 0 TO cellNum
'	FOR col = 0 TO cellNum

''		IF (col > row) AND ((M@@[row,col]) OR (M@@[col,row])) THEN
'		IF (col != row) AND (M@@[row,col]) THEN

'			count = 0

'			FOR x = 0 TO cellNum

'				IF (M@@[row,x] AND M@@[col,x]) THEN INC count

'			NEXT x

'			prex = row/142 
'			prey = row MOD 142
'			postx = col/142 
'			posty = col MOD 142

''			IF (M@@[row,col]) THEN

'				FOR z = 0 TO preSynCount[prex,prey]-1
	
'					IF (preSynCell@@[0,prex,prey,z] = postx) AND (preSynCell@@[1,prex,prey,z] = posty) THEN
	
'						numCommonPre%%[prex,prey,z] = count
	
'						EXIT FOR
	
'					END IF	
'				NEXT z
''			END IF

''			IF (M@@[col,row]) THEN

''				FOR z = 0 TO preSynCount[postx,posty]-1
	
''					IF (preSynCell@@[0,postx,posty,z] = prex) AND (preSynCell@@[1,postx,posty,z] = prey) THEN
	
''						numCommonPre%%[postx,posty,z] = count
	
''						EXIT FOR
	
''					END IF	
''				NEXT z
''			END IF

'		END IF
'	NEXT col
''PRINT row
'NEXT row

''PRINT "counting presyn common neighbors..."

''FOR col = 0 TO cellNum
''	FOR row = 0 TO cellNum

''		IF (row > col) AND ((M@@[col,row]) OR (M@@[row,col])) THEN

''			count = 0

''			FOR x = 0 TO cellNum

''				IF (M@@[col,x] AND M@@[row,x]) THEN INC count

''			NEXT x

''			prex = row/142 
''			prey = row MOD 142
''			postx = col/142 
''			posty = col MOD 142

''			IF (M@@[col,row]) THEN

''				FOR z = 0 TO preSynCount[postx,posty]-1
	
''					IF (preSynCell@@[0,postx,posty,z] = prex) AND (preSynCell@@[1,postx,posty,z] = prey) THEN
	
''						numCommonPre%%[postx,posty,z] = count
	
''						EXIT FOR
	
''					END IF	
''				NEXT z
''			END IF

''			IF (M@@[row,col]) THEN

''				FOR z = 0 TO preSynCount[prex,prey]-1
	
''					IF (preSynCell@@[0,prex,prey,z] = postx) AND (preSynCell@@[1,prex,prey,z] = posty) THEN
	
''						numCommonPre%%[prex,prey,z] = count
	
''						EXIT FOR
	
''					END IF	
''				NEXT z
''			END IF

''		END IF
''	NEXT row
' ''PRINT col
''NEXT col

PRINT "now doing syn strs"

FOR x = 0 TO 141
	FOR y = 0 TO 141
		
		totPost = 0
		totPre = 0
		
		FOR z = 0 TO synNum-1

			totPost = totPost + numCommonPost%%[x,y,z]
			totPre = totPre + numCommonPre%%[x,y,z]

			IF numCommonPre%%[x,y,z] > maxPre! THEN maxPre! = numCommonPre%%[x,y,z]
			IF numCommonPost%%[x,y,z] > maxPost! THEN maxPost! = numCommonPost%%[x,y,z]

		NEXT z

		postCC![x,y] = SINGLE(totPost)/synNum
		preCC![x,y] = SINGLE(totPre)/synNum

	NEXT y
NEXT x

FOR x = 0 TO 141
	FOR y = 0 TO 141

		IF postCC![x,y] > maxPostCC! THEN maxPostCC! = postCC![x,y]
		IF preCC![x,y] > maxPreCC! THEN maxPreCC! = preCC![x,y]

	NEXT y
NEXT x

FOR x = 0 TO 141
	FOR y = 0 TO 141
		FOR z = 0 TO synNum-1

			tempPostCC! = postCC![connMatrix@@[0,x,y,z],connMatrix@@[1,x,y,z]]/maxPostCC!
			tempPreCC! = preCC![connMatrix@@[0,x,y,z],connMatrix@@[1,x,y,z]]/maxPreCC!
			
			targetCC! = Log( tempPostCC! ) + 3
			targetCC! = (targetCC! + Log( tempPreCC! ) + 3 ) / 2.0
			
			IF targetCC! < 0 THEN targetCC! = 0

			pre! = (numCommonPre%%[x,y,z]/maxPre!)
			post! = (numCommonPost%%[x,y,z]/maxPost!)
			connStr![x,y,z] = pre! * post! * targetCC!

		NEXT z
	NEXT y
NEXT x

FOR x = 0 TO 141
	FOR y = 0 TO 141
		FOR z = 0 TO synNum-1

			IF connStr![x,y,z] > maxStr! THEN maxStr! = connStr![x,y,z]

		NEXT z
	NEXT y
NEXT x

'PRINT "x = "x
'PRINT "y = "y
'FOR k = 0 TO synNum-1
'PRINT "xx = "connMatrix![x,y,k,0]
'PRINT "yy = "connMatrix![x,y,k,1]
'PRINT "str = "connMatrix![x,y,k,2]
'NEXT k

PRINT "...done"

END SUB


SUB WriteConns

file = OPEN(connFile$,$$WR)
file1 = OPEN(commFile$,$$WR)

PRINT "writing postsyn conns to file..."

WRITE [file],maxStr!

FOR x = 0 TO 141
PRINT "x = "x
	FOR y = 0 TO 141

		p! = postCC![x,y]
		WRITE [file1],p!

		FOR k = 0 TO synNum-1

			npost = numCommonPost%%[x,y,k]
			npre = numCommonPre%%[x,y,k]

			xx = connMatrix@@[0,x,y,k]
			yy = connMatrix@@[1,x,y,k]
			str! = connStr![x,y,k]

'PRINT "writing to file x,y,xx,yy,str! = " x,y,xx,yy,str!

			WRITE [file],xx,yy,str!
			WRITE [file1],npost,npre

		NEXT k
	NEXT y
NEXT x
CLOSE(file)
CLOSE(file1)

file = OPEN(preconnFile$,$$WR)

PRINT "writing presyn to file..."

FOR x = 0 TO 141
PRINT "x = "x
	FOR y = 0 TO 141

		count = preSynCount[x,y]
		p! = preCC![x,y]

		WRITE [file],count,p!

		FOR k = 0 TO preSynCount[x,y]-1

			xx = preSynCell@@[0,x,y,k]
			yy = preSynCell@@[1,x,y,k]

			WRITE [file],xx,yy

		NEXT k
	NEXT y
NEXT x
CLOSE(file)

PRINT "maxStr! =",maxStr!

END SUB


SUB ReadConns

file = OPEN(connFile$,$$RD)
file1 = OPEN(commFile$,$$RD)

PRINT "reading postsyn conns from file..."

READ [file],maxStr!

FOR x = 0 TO 141
PRINT "x = "x
	FOR y = 0 TO 141

		READ [file1],p!
		postCC![x,y] = p!

		FOR k = 0 TO synNum-1

		READ [file],xx,yy,str!
		READ [file1],npost,npre

			connMatrix@@[0,x,y,k] = xx
			connMatrix@@[1,x,y,k] = yy
			connStr![x,y,k] = str!

			numCommonPost%%[x,y,k] = npost
			numCommonPre%%[x,y,k] = npre

'PRINT "numCommonPost%%[x,y,k] =",numCommonPost%%[x,y,k]
'PRINT "str =",str!

		NEXT k
	NEXT y
NEXT x
CLOSE(file)
CLOSE(file1)

file = OPEN(preconnFile$,$$RD)

PRINT "reading presyn from file..."

FOR x = 0 TO 141
PRINT "x = "x
	FOR y = 0 TO 141

		READ [file],count,p!

		preSynCount[x,y] = count
		preCC![x,y] = p!

		FOR k = 0 TO preSynCount[x,y]-1

			READ [file],xx,yy

			preSynCell@@[0,x,y,k] = xx
			preSynCell@@[1,x,y,k] = yy

		NEXT k
	NEXT y
NEXT x
CLOSE(file)

PRINT "maxStr! =",maxStr!

END SUB

SUB RandPoissonConns

PRINT "Assigning poisson synaptic strengths..."

FOR x = 0 TO 141
	FOR y = 0 TO 141
		FOR z = 0 TO synNum-1

			L! = Exp(-2)
			
				k = 0
				p! = 1
			
				DO WHILE (p! > L!)
				
					INC k
					u! = XstRandomUniform()
					p! = p! * u!
				
				LOOP
			
				end! = k * XstRandomUniform()/5.5

			connStr![x,y,z] = end!

		NEXT z
	NEXT y
NEXT x

maxStr! = 0

FOR x = 0 TO 141
	FOR y = 0 TO 141
		FOR z = 0 TO synNum-1

			IF connStr![x,y,z] > maxStr! THEN maxStr! = connStr![x,y,z]

		NEXT z
	NEXT y
NEXT x

file = OPEN(randConnFile$,$$WR)

PRINT "rewriting postsyn conns to file..."

WRITE [file],maxStr!

FOR x = 0 TO 141
PRINT "x = "x
	FOR y = 0 TO 141

		FOR k = 0 TO synNum-1

			xx = connMatrix@@[0,x,y,k]
			yy = connMatrix@@[1,x,y,k]
			str! = connStr![x,y,k]

'PRINT "writing to file x,y,xx,yy,str! = " x,y,xx,yy,str!

			WRITE [file],xx,yy,str!

		NEXT k
	NEXT y
NEXT x
CLOSE(file)

PRINT "...done"

PRINT "maxStr! =",maxStr!

END SUB

SUB ReadPoissonConns

file = OPEN(randConnFile$,$$RD)

PRINT "reading poisson postsyn strs from file..."

READ [file],maxStr!

FOR x = 0 TO 141
PRINT "x = "x
	FOR y = 0 TO 141

		FOR k = 0 TO synNum-1

		READ [file],xx,yy,str!

			connMatrix@@[0,x,y,k] = xx
			connMatrix@@[1,x,y,k] = yy
			connStr![x,y,k] = str!

'PRINT "str =",str!

		NEXT k
	NEXT y
NEXT x
CLOSE(file)

PRINT "maxStr! =",maxStr!

END SUB

SUB ShuffleSynAmps

PRINT "shuffling postsyn strengths..."

FOR i = 0 TO 40000000

	x = XstRandomRange (0,141)
	y = XstRandomRange (0,141)
	
	syn = XstRandomRange (0,999)
	
	xx = XstRandomRange (0,141)
	yy = XstRandomRange (0,141)
	
	syn1 = XstRandomRange (0,999)
	
	tempstr! = connStr![x,y,syn]
	
	connStr![x,y,syn] = connStr![xx,yy,syn1]
	
	connStr![xx,yy,syn1] = tempstr!

NEXT i

maxStr! = 0

FOR x = 0 TO 141
	FOR y = 0 TO 141
		FOR z = 0 TO synNum-1

			IF connStr![x,y,z] > maxStr! THEN maxStr! = connStr![x,y,z]

		NEXT z
	NEXT y
NEXT x

file = OPEN(shuffledConnFile$,$$WR)

PRINT "rewriting postsyn conns to file..."

WRITE [file],maxStr!

FOR x = 0 TO 141
PRINT "x = "x
	FOR y = 0 TO 141

		FOR k = 0 TO synNum-1

			xx = connMatrix@@[0,x,y,k]
			yy = connMatrix@@[1,x,y,k]
			str! = connStr![x,y,k]

'PRINT "writing to file x,y,xx,yy,str! = " x,y,xx,yy,str!

			WRITE [file],xx,yy,str!

		NEXT k
	NEXT y
NEXT x
CLOSE(file)

PRINT "...done"

PRINT "maxStr! =",maxStr!

END SUB

SUB ReadShuffledConns

file = OPEN(shuffledConnFile$,$$RD)

PRINT "reading shuffled postsyn strengths from file..."

READ [file],maxStr!

FOR x = 0 TO 141
PRINT "x = "x
	FOR y = 0 TO 141

		FOR k = 0 TO synNum-1

		READ [file],xx,yy,str!

			connMatrix@@[0,x,y,k] = xx
			connMatrix@@[1,x,y,k] = yy
			connStr![x,y,k] = str!

'PRINT "str =",str!

		NEXT k
	NEXT y
NEXT x
CLOSE(file)

PRINT "maxStr! =",maxStr!

END SUB

SUB RedoConnns

PRINT "Recalculating synaptic strengths..."
maxPost! = 0
maxPre! = 0
maxPostCC! = 0
maxPreCC! = 0
maxStr! = 0

FOR x = 0 TO 141
	FOR y = 0 TO 141
		
		totPost = 0
		totPre = 0
		
		FOR z = 0 TO synNum-1

			totPost = totPost + numCommonPost%%[x,y,z]
			totPre = totPre + numCommonPre%%[x,y,z]

			IF numCommonPre%%[x,y,z] > maxPre! THEN maxPre! = numCommonPre%%[x,y,z]
			IF numCommonPost%%[x,y,z] > maxPost! THEN maxPost! = numCommonPost%%[x,y,z]

		NEXT z

		postCC![x,y] = SINGLE(totPost)/synNum
		preCC![x,y] = SINGLE(totPre)/synNum

'PRINT "postCC![x,y] =",postCC![x,y]
'PRINT "maxPre! =",maxPre!
'PRINT "maxPost! =",maxPost!

	NEXT y
NEXT x

FOR x = 0 TO 141
	FOR y = 0 TO 141

		IF postCC![x,y] > maxPostCC! THEN maxPostCC! = postCC![x,y]
		IF preCC![x,y] > maxPreCC! THEN maxPreCC! = preCC![x,y]

	NEXT y
NEXT x

FOR x = 0 TO 141
	FOR y = 0 TO 141
		FOR z = 0 TO synNum-1

			tempPostCC! = postCC![connMatrix@@[0,x,y,z],connMatrix@@[1,x,y,z]]/maxPostCC!
			tempPreCC! = preCC![connMatrix@@[0,x,y,z],connMatrix@@[1,x,y,z]]/maxPreCC!

			targetCC! = Log( tempPostCC! ) + 3
			targetCC! = (targetCC! + Log( tempPreCC! ) + 3 ) / 2.0
			
			IF targetCC! < 0 THEN targetCC! = 0

			pre! = (numCommonPre%%[x,y,z]/maxPre!)
			post! = (numCommonPost%%[x,y,z]/maxPost!)

'			pre! = numCommonPre%%[x,y,z]
'			post! = numCommonPost%%[x,y,z]

'			connStr![x,y,z] = pre! * post! + tempPostCC! + tempPreCC! '* targetCC!

			connStr![x,y,z] = pre! * post!

'PRINT "connStr![x,y,z] =",connStr![x,y,z]

		NEXT z
	NEXT y
NEXT x

maxStr! = 0

FOR x = 0 TO 141
	FOR y = 0 TO 141
		FOR z = 0 TO synNum-1

			IF connStr![x,y,z] > maxStr! THEN maxStr! = connStr![x,y,z]

		NEXT z
	NEXT y
NEXT x

PRINT "...done"

PRINT "maxStr! =",maxStr!

END SUB

SUB CountRecip

PRINT "Counting all reciprocal connections..."

DIM recipAmp! [2,3500000]
'DIM trueRecipAmp! [2,1700000]

numRecip = 0
totAmp! = 0
totDiff! = 0
maxDiff! = 0

FOR x = 0 TO 141
	FOR y = 0 TO 141
		FOR z = 0 TO synNum-1
			FOR k = 0 TO preSynCount[x,y]-1

				IF ((connMatrix@@[0,x,y,z] = preSynCell@@[0,x,y,k]) AND (connMatrix@@[1,x,y,z] = preSynCell@@[1,x,y,k])) THEN

					INC numRecip

					x1 = preSynCell@@[0,x,y,k]
					y1 = preSynCell@@[1,x,y,k]

					FOR j = 0 TO synNum-1
	
						IF ((connMatrix@@[0,x1,y1,j] = x) AND (connMatrix@@[1,x1,y1,j] = y)) THEN EXIT FOR
	
					NEXT j

					recipAmp![0,numRecip-1] = connStr![x,y,z]

					recipAmp![1,numRecip-1] = connStr![x1,y1,j]

					IF numRecip > 1 THEN

						FOR a = 0 TO numRecip-2
					
							IF (recipAmp![0,a] = recipAmp![1,numRecip-1]) AND (recipAmp![1,a] = recipAmp![0,numRecip-1]) THEN
					
								DEC numRecip
								EXIT FOR
					
							END IF
						NEXT a
					END IF

					diff! = ABS(recipAmp![0,numRecip-1] - recipAmp![1,numRecip-1])

					IF diff! > maxDiff! THEN maxDiff! = diff!

					totDiff! = totDiff! + diff!

					totAmp! = totAmp! + recipAmp![0,numRecip-1] + recipAmp![1,numRecip-1]

				END IF
			NEXT k
		NEXT z
	NEXT y
PRINT "x = "x
NEXT x

'count = 0

'FOR x = 0 TO numRecip-1

'PRINT x

'	trueRecipAmp![0,count] = recipAmp![0,x]
'	trueRecipAmp![1,count] = recipAmp![1,x]
'	INC count

'	FOR y = 0 TO count-1

'		IF trueRecipAmp![0,y] = recipAmp![1,x] AND trueRecipAmp![1,y] = recipAmp![0,x] THEN

'			DEC count
'			EXIT FOR

'		END IF
'	NEXT y
'NEXT x

avAmp! = totAmp! / (numRecip*2)
avDiff! = totDiff! / numRecip

PRINT "numRecip =",numRecip
PRINT "avAmp! =",avAmp!
PRINT "avDiff! =",avDiff!
PRINT "maxDiff! =",maxDiff!

Graphics ($$M_RECIPAMP)

END SUB

SUB PathLength

totDeg! = 0
numTested! = 100

FOR c = 1 TO numTested!
	
	PRINT "% done:",c/numTested!*100.0

	deg = 0

	x = XstRandomRange (0,141)
	y = XstRandomRange (0,141)

	xx = x
	yy = y

	DO WHILE (x=xx) AND (y=yy)

	xx = XstRandomRange (0,141)
	yy = XstRandomRange (0,141)

	LOOP

PRINT "x=",x
PRINT "y=",y
PRINT "xx=",xx
PRINT "yy=",yy

	FOR z = 0 TO synNum-1

		IF (connMatrix@@[0,x,y,z] = xx) AND (connMatrix@@[1,x,y,z] = yy) THEN
PRINT "deg1"
			deg = 1
			EXIT FOR
		END IF
	NEXT z

	IFF (deg) THEN

		FOR z = 0 TO synNum-1

			IF (deg) THEN EXIT FOR
		
			x2 = connMatrix@@[0,x,y,z]
			y2 = connMatrix@@[1,x,y,z]

			FOR zz = 0 TO synNum-1

				IF (connMatrix@@[0,x2,y2,zz] = xx) AND (connMatrix@@[1,x2,y2,zz] = yy) THEN
PRINT "deg2"
					deg = 2
					EXIT FOR
				END IF
			NEXT zz
		NEXT z
	END IF

	IFF (deg) THEN

		FOR z = 0 TO synNum-1

			IF (deg) THEN EXIT FOR
		
			x2 = connMatrix@@[0,x,y,z]
			y2 = connMatrix@@[1,x,y,z]

			FOR zz = 0 TO synNum-1

				IF (deg) THEN EXIT FOR

				x3 = connMatrix@@[0,x2,y2,zz]
				y3 = connMatrix@@[1,x2,y2,zz]

				FOR zzz = 0 TO synNum-1

					IF (connMatrix@@[0,x3,y3,zzz] = xx) AND (connMatrix@@[1,x3,y3,zzz] = yy) THEN
PRINT "deg3"
						deg = 3
						EXIT FOR
					END IF
				NEXT zzz
			NEXT zz
		NEXT z
	END IF

	IFF (deg) THEN PRINT "deg > 3"

	totDeg! = totDeg! + deg

NEXT c

PRINT "Mean pathlength from "numTested!" cells is",totDeg!/numTested!

END SUB

SUB NeighborAffinity

DIM meanDist![142,142]

NAff = 1
grandSumDist! = 0

FOR x = 0 TO 141
	FOR y = 0 TO 141

		or1! = pyrsAttributes![0,x,y]
		sf1! = pyrsAttributes![1,x,y]
		rp1! = pyrsAttributes![2,x,y]
		p41! = pyrsAttributes![3,x,y]

		sumDist! = 0

		FOR z = 0 TO synNum-1

			xx = connMatrix@@[0,x,y,z]
			yy = connMatrix@@[1,x,y,z]

			or2! = pyrsAttributes![0,xx,yy]
			sf2! = pyrsAttributes![1,xx,yy]
			rp2! = pyrsAttributes![2,xx,yy]
			p42! = pyrsAttributes![3,xx,yy]

			dist! = CalculateCellDistance (or1!,sf1!,rp1!,p41!,or2!,sf2!,rp2!,p42!)

			sumDist! = sumDist! + dist!

		NEXT z

		meanDist![x,y] = sumDist! / synNum

		grandSumDist! = grandSumDist! + meanDist![x,y]

	NEXT y
NEXT x

grandMeanDist! = grandSumDist! / (142*142)

PRINT "grandMeanDist! =",grandMeanDist!

Graphics ($$M_NeighborAffinity)

END SUB

SUB OrientConnProb
' Finds prob of conn in 50um square around each cell for 3 orient diffs. Note only makes sense for rat conn.

DIM postOrient![142,142,3]
DIM grandPostOrient![2]

FOR x = 0 TO 141
	FOR y = 0 TO 141

		or1! = pyrsAttributes![0,x,y]

		FOR a = -3 TO 3
			FOR b = -3 TO 3
				FOR z = 0 TO synNum-1
		
					xx = connMatrix@@[0,x,y,z]
					yy = connMatrix@@[1,x,y,z]
	
					IF (xx = a) AND (yy = b) THEN 
	
						or2! = pyrsAttributes![0,xx,yy]
			
						diff! = ABS(or1! - or2!)
			
						IF (diff! > 90) THEN diff! = 180 - diff!

						SELECT CASE TRUE

							CASE (diff! < 22.5)
								INC postOrient![x,y,0]
							CASE (diff! > 67.5)
								INC postOrient![x,y,2]
							CASE ELSE
								INC postOrient![x,y,1]

						END SELECT
						EXIT FOR
					END IF
				NEXT z
			NEXT b
		NEXT a

		postOrient![x,y,0] = (postOrient![x,y,0] / 12) * 8.333
		postOrient![x,y,1] = (postOrient![x,y,1] / 24) * 4.167
		postOrient![x,y,2] = (postOrient![x,y,2] / 12) * 8.333

		FOR k = 0 TO 2

			grandPostOrient![k] = grandPostOrient![k] + postOrient![x,y,k]

		NEXT k
	NEXT y
NEXT x

FOR k = 0 TO 2

	grandPostOrient![k] = grandPostOrient![k] / (142*142)

NEXT k

	PRINT "prob conn for < 22.5 =",grandPostOrient![0]
	PRINT "prob conn for btw =",grandPostOrient![1]
	PRINT "prob conn for > 67.5 =",grandPostOrient![2]

END SUB

END FUNCTION ()


'
' #################################
' #####  AssignAttributes (id)  #####
' #################################
'
FUNCTION  AssignAttributes (id)

SHARED pyrsAttributes![]
SHARED rat
SHARED sdOrient!
SHARED addOrient!
SHARED addSf!
SHARED sdSf!

DIM pyrsAttributes![4,142,142]

SELECT CASE id
	
	CASE $$M_STARTRAT

		rat = 1
		File$ = "rParams.dat"		
		GOSUB RatParams

	CASE $$M_STARTCAT

		rat = 0
		File$ = "cParams.dat"		
		GOSUB FullOrient
		GOSUB SpatialFreq
		GOSUB UniformParam
		GOSUB Param4
				
END SELECT

'GOSUB WriteParams
GOSUB ReadParams

SUB RatParams

FOR x = 0 TO 141
	FOR y = 0 TO 141

		pyrsAttributes![0,x,y] = XstRandomUniform() * 180

'		PRINT pyrsAttributes![0,x,y]

	NEXT y
NEXT x

FOR x = 0 TO 141
	FOR y = 0 TO 141

		pyrsAttributes![1,x,y] = XstRandomUniform() * 2

'		PRINT pyrsAttributes![1,x,y]

	NEXT y
NEXT x

'last two params are not circular variables (like spF in cx) so distance minimum for intermediate values

FOR x = 0 TO 141
	FOR y = 0 TO 141

		pyrsAttributes![2,x,y] = XstRandomUniform()

'		PRINT pyrsAttributes![2,x,y]

	NEXT y
NEXT x

FOR x = 0 TO 141
	FOR y = 0 TO 141

		pyrsAttributes![3,x,y] = XstRandomUniform()

'		PRINT pyrsAttributes![3,x,y]

	NEXT y
NEXT x

END SUB

SUB Param4

FOR x = 0 TO 141
	FOR y = 0 TO 141

		pyrsAttributes![3,x,y] = XstRandomUniform()

'		PRINT pyrsAttributes![3,x,y]

	NEXT y
NEXT x

END SUB


SUB UniformParam

FOR x = 0 TO 141
	FOR y = 0 TO 141

		pyrsAttributes![2,x,y] = XstRandomUniform()

'		PRINT pyrsAttributes![2,x,y]

	NEXT y
NEXT x
END SUB


SUB SpatialFreq

sf! = 0
addSf! = 0.0140845
sdSf! = 0.2

FOR y = 0 TO 141
	FOR x = 0 TO 141

		pyrsAttributes![1,x,y] = sf! + sdSf! * Sqrt(-2*Log(XstRandomUniform())) * Cos(2*$$PI*XstRandomUniform())

		IF (pyrsAttributes![1,x,y] > 2) THEN
			pyrsAttributes![1,x,y] = pyrsAttributes![1,x,y] - 2.0
		END IF
		IF (pyrsAttributes![1,x,y] < 0) THEN
			pyrsAttributes![1,x,y] = pyrsAttributes![1,x,y] + 2.0
		END IF

'		PRINT pyrsAttributes![1,x,y]

	NEXT x
	sf! = sf! + addSf!

NEXT y

'PRINT "sf! = "sf!

END SUB


SUB HalfOrient

orient! = 90
addOrient! = 1.268
sdOrient! = 7

FOR x = 0 TO 141
	FOR y = 0 TO 141

		pyrsAttributes![0,x,y] = orient!+sdOrient! * Sqrt(-2*Log(XstRandomUniform())) * Cos(2*$$PI*XstRandomUniform())

		IF (pyrsAttributes![0,x,y] > 180) THEN
			pyrsAttributes![0,x,y] = 180 + (180 - pyrsAttributes![0,x,y])
		END IF
		IF (pyrsAttributes![0,x,y] < 90) THEN
			pyrsAttributes![0,x,y] = 90 + (90 - pyrsAttributes![0,x,y])
		END IF

'		PRINT pyrsAttributes![0,x,y]

	NEXT y
	orient! = orient! + addOrient!

NEXT x

'PRINT "orient! = "orient!

END SUB


SUB FullOrient

orient! = 0
addOrient! = 1.268								'scaling factor between cell number (0 to 141) and orient (0 to 180)
sdOrient! = 7

FOR x = 0 TO 141
	FOR y = 0 TO 141

		pyrsAttributes![0,x,y] = orient!+sdOrient! * Sqrt(-2*Log(XstRandomUniform())) * Cos(2*$$PI*XstRandomUniform())

		IF (pyrsAttributes![0,x,y] < 0) THEN
			pyrsAttributes![0,x,y] = pyrsAttributes![0,x,y] + 180
		END IF
		IF (pyrsAttributes![0,x,y] > 180) THEN
			pyrsAttributes![0,x,y] = pyrsAttributes![0,x,y] - 180
		END IF

'		PRINT pyrsAttributes![0,x,y]

	NEXT y
	orient! = orient! + addOrient!

NEXT x

'PRINT "orient! = "orient!

END SUB


SUB WriteParams

file = OPEN(File$,$$WR)

FOR x = 0 TO 141
	FOR y = 0 TO 141

  or! = pyrsAttributes![0,x,y]
 	sf! = pyrsAttributes![1,x,y]
	rp! = pyrsAttributes![2,x,y]
	p4! = pyrsAttributes![3,x,y]

'PRINT "writing to file x,y,pyrsAttributes![0,x,y],pyrsAttributes![1,x,y],pyrsAttributes![2,x,y] = " x,y,pyrsAttributes![0,x,y],pyrsAttributes![1,x,y],pyrsAttributes![2,x,y]

  WRITE [file], x,y,or!,sf!,rp!,p4!

	NEXT y
NEXT x
CLOSE(file)
END SUB


SUB ReadParams

file = OPEN(File$,$$RD)
FOR x = 0 TO 141
	FOR y = 0 TO 141

  READ [file], x,y,or!,sf!,rp!,p4!

  pyrsAttributes![0,x,y] = or!
  pyrsAttributes![1,x,y] = sf!
	pyrsAttributes![2,x,y] = rp!
	pyrsAttributes![3,x,y] = p4!

'PRINT "read from file x,y,pyrsAttributes![0,x,y],pyrsAttributes![1,x,y],pyrsAttributes![2,x,y] = " x,y,pyrsAttributes![0,x,y],pyrsAttributes![1,x,y],pyrsAttributes![2,x,y]

	NEXT y
NEXT x
CLOSE(file)
END SUB

END FUNCTION

'
'
' ######################################
' #####  CalculateCellDistance ()  #####
' ######################################
'
'calculates distance between params of 2 cells

FUNCTION SINGLE CalculateCellDistance (x0!,x1!,x2!,x3!,y0!,y1!,y2!,y3!)

x0! = (x0!/90) - 1
x1! = x1! - 1

y0! = (y0!/90) - 1
y1! = y1! - 1

a! = x0! - y0!

IF (a!>1) THEN
	a! = a! - 2
END IF

IF (a!<-1) THEN
	a! = a! + 2
END IF

b! = x1! - y1!

IF (b!>1) THEN
	b! = b! - 2
END IF

IF (b!<-1) THEN
	b! = b! + 2
END IF

END FUNCTION Sqrt( a!*a! + b!*b! + (x2!-y2!)*(x2!-y2!) + (x3!-y3!)*(x3!-y3!) )

'
'
' ##########################################
' #####  CalculatePhyscialDistance ()  #####
' ##########################################
'
'calculates physical distance between 2 cells

FUNCTION  SINGLE CalculatePhyscialDistance (x1,y1,x2,y2)

a = ABS(x1-x2)

b1 = (142 - x1) + x2

b2 = (142 - x2) + x1

b = b1

IF (b2 < b) THEN
	b = b2
END IF

IF (a < b) THEN
	b = a
END IF

'PRINT "xdiff is "b

aa = ABS(y1-y2)

bb1 = (142 - y1) + y2

bb2 = (142 - y2) + y1

bb = bb1

IF (bb2 < bb) THEN
	bb = bb2
END IF

IF (aa < bb) THEN
	bb = aa
END IF

'PRINT "ydiff is "bb

END FUNCTION Sqrt( b*b + bb*bb )

'
'
' ##################################
' #####  CalculateDistance ()  #####
' ##################################
'calculates distance between params of cell and stimulus

FUNCTION SINGLE CalculateDistance (x0!,x1!,x2!,x3!,y0!,y1!,y2!,y3!)

'Max difference for orient is 90 deg

x0! = (x0!/90) - 1
y0! = (y0!*2) - 1

'PRINT "x0! = "x0!
'PRINT "y0! = "y0!

x1! = x1! - 1
y1! = (y1!*2) - 1

a! = x0! - y0!

IF (a!>1) THEN
	a! = a! - 2
END IF

IF (a!<-1) THEN
	a! = a! + 2
END IF

b! = x1! - y1!

IF (b!>1) THEN
	b! = b! - 2
END IF

IF (b!<-1) THEN
	b! = b! + 2
END IF

'PRINT "x1! = "x1!
'PRINT "y1! = "y1!

END FUNCTION Sqrt( a!*a! + b!*b! + (x2!-y2!)*(x2!-y2!) + (x3!-y3!)*(x3!-y3!))

'
'
' #############################
' #####  Stimulus ()  #####
' #############################
'
FUNCTION  Stimulus (stim)

SHARED pyrsAttributes![]
SHARED distFile0$
SHARED distFile1$
SHARED orOffset!

'PRINT "distFile$ = ",distFile$
'PRINT "orOffset! = ",orOffset!

cellNum = 20163									' one less than # of cells 
DIM stimulus![4]
DIM distance![cellNum+1,3]
' DIM b![3]
DIM origArray [cellNum+1,2]
DIM orderArray [0]
DIM tempArray! [cellNum+1]

GOSUB ManualStim
'GOSUB RandomStim
GOSUB GetDistances
GOSUB SortDistances
GOSUB WriteDistances


SUB ManualStim

stimulus![0] =0.5 + orOffset!
stimulus![1] =0.5
stimulus![2] =0.5
stimulus![3] =0.5

FOR z = 0 TO 3

	PRINT "stimulus!["z"] = "stimulus![z]

NEXT z
END SUB

SUB RandomStim

FOR z = 0 TO 3

	stimulus![z] = XstRandomUniform()
	PRINT "stimulus!["z"] = "stimulus![z]

NEXT z
END SUB

SUB GetDistances

count = 0
FOR x = 0 TO 141
	FOR y = 0 TO 141

		distance![count,0] = x
		distance![count,1] = y
		distance![count,2] = CalculateDistance(pyrsAttributes![0,x,y],pyrsAttributes![1,x,y],pyrsAttributes![2,x,y],pyrsAttributes![3,x,y],stimulus![0],stimulus![1],stimulus![2],stimulus![3])

'PRINT "distance![count,0] = " distance![count,0]
'PRINT "distance![count,1] = " distance![count,1]
'PRINT "pyrsAttributes![0,x,y] = "pyrsAttributes![0,x,y]
'PRINT "pyrsAttributes![1,x,y] = "pyrsAttributes![1,x,y]
'PRINT "pyrsAttributes![2,x,y] = "pyrsAttributes![2,x,y]
'PRINT "pyrsAttributes![3,x,y] = "pyrsAttributes![3,x,y]
'PRINT "distance![count,2] = " distance![count,2]

		INC count

	NEXT y
NEXT x

END SUB

SUB SortDistances

FOR x = 0 TO cellNum
	tempArray![x] = distance![x,2]
	origArray[x,0] = distance![x,0]
	origArray[x,1] = distance![x,1]
NEXT x

'FOR x = 0 TO cellNum

'	IF (tempArray![x] = 0) THEN
'		PRINT x
'		PRINT "tempArray![x]",tempArray![x]
'	ENDIF
	
'NEXT x

	flag = $$SortIncreasing
'	XstQuickSort (@tempArray![], @orderArray[], 0, UBOUND(tempArray![]), flag)
	XstQuickSort (@tempArray![], @orderArray[], 0, cellNum, flag)

'FOR x = 0 TO cellNum

'	IF (tempArray![x] = 0) THEN
'		PRINT x
'		PRINT "tempArray![x]2",tempArray![x]
'	ENDIF
	
'NEXT x

'PRINT "tempArray![0]",tempArray![0]
'PRINT "tempArray![1]",tempArray![1]

FOR x = 0 TO cellNum
	distance![x,2] = tempArray![x]
	distance![x,0] = origArray[orderArray[x],0]
	distance![x,1] = origArray[orderArray[x],1]
NEXT x

'PRINT "...done"

'FOR x = 0 TO cellNum
'	PRINT "distance![x,0] "distance![x,0]
'	PRINT "distance![x,1] "distance![x,1]
'	PRINT "distance![x,2] "distance![x,2]
'NEXT x

'PRINT "distance![0,0] = " distance![0,0]
'PRINT "distance![0,1] = " distance![0,1]
'PRINT "distance![0,2] = " distance![0,2]

END SUB

SUB WriteDistances

SELECT CASE stim

	CASE $$C_FIRST

		file = OPEN(distFile0$,$$WR)

	CASE $$C_SECOND
		
		file = OPEN(distFile1$,$$WR)

END SELECT

FOR a = 0 TO cellNum

	x = distance![a,0]
	y = distance![a,1]
	d! = distance![a,2]

'PRINT "writing to file x,y,d! = " x,y,d!

	WRITE [file], x,y,d!

NEXT a
CLOSE(file)
END SUB

END FUNCTION

FUNCTION Graphics (gid)
' WinX graphics routines here	

	SHARED currentPen
	SHARED redPen
	SHARED greenPen
	SHARED bluePen
	SHARED magentaPen
	SHARED blackPen
	SHARED whitePen
	SHARED	Pen0
	SHARED	Pen1
	SHARED	Pen2
	SHARED	Pen3
	SHARED	Pen4
	SHARED	Pen5
	SHARED	Pen6
	SHARED	Pen7
	SHARED	Pen8
	SHARED	Pen9
	SHARED	Pen10
	SHARED	Pen11
	SHARED	Pen12
	SHARED	Pen13
	SHARED	Pen14
	SHARED	Pen15
	SHARED	Pen16
	SHARED	Pen17
	SHARED	Pen18
	SHARED	Pen19
	SHARED	Pen20
	SHARED	Pen21
	SHARED	Pen22
	SHARED	Pen23
	SHARED	Pen24
	SHARED	Pen25
	SHARED	Brush0
	SHARED	Brush1
	SHARED	Brush2
	SHARED	Brush3
	SHARED	Brush4
	SHARED	Brush5
	SHARED	Brush6
	SHARED	Brush7
	SHARED	Brush8
	SHARED	Brush9
	SHARED	Brush10
	SHARED	Brush11
	SHARED	Brush12
	SHARED	Brush13
	SHARED	Brush14
	SHARED	Brush15
	SHARED	Brush16
	SHARED	Brush17
	SHARED	Brush18
	SHARED	Brush19
	SHARED	Brush20
	SHARED	Brush21
	SHARED	Brush22
	SHARED	Brush23
	SHARED	Brush24
	SHARED	Brush25
	SHARED blackBrush
	SHARED whiteBrush
	SHARED	magentaBrush
	SHARED	currentBrush
	SHARED #clearWin
	SHARED	pyrsAttributes![]
	SHARED	distFile0$
	SHARED	distFile1$
	SHARED  orOffset!
	SHARED connMatrix@@[]
	SHARED connStr![]
	SHARED synNum
	SHARED totCells
	SHARED showx
	SHARED showy
	SHARED rat
	SHARED commFile$
	SHARED numCommonPre%%[]
	SHARED numCommonPost%%[]
	SHARED preSynCell@@[]
	SHARED preSynCount[]
	SHARED maxStr!
	SHARED postCC![]
	SHARED cellsAtDist[]
	SHARED maxPhysDist!
	SHARED sdOrient!
	SHARED addOrient!
	SHARED addSf!
	SHARED sdSf!
	SHARED recipAmp! []
	SHARED numRecip
	SHARED v![]
	SHARED time
	SHARED spikeFile$
	SHARED maxSp!
	SHARED meanDist![]
	buttonOffset = 4
	m = 6
	connCase = 10
	comma$ = ","
		

		SELECT CASE gid

		CASE $$M_NeighborAffinity
'Display mean param distance of postsyn targets of all cells

			#clearWin = #winConnGraph
			Graphics ($$M_CLEAR)

			FOR x = 0 TO 141
				FOR y = 0 TO 141

				a = x*6
				h = meanDist![x,y] * 300

				WinXDrawFilledRect (#winConnGraph, Pen25, Brush25, a, buttonOffset*m+h, a+3, buttonOffset*m+h+3)
				WinXUpdate (#winConnGraph)

				NEXT y
			NEXT x

		CASE $$M_RODYN
'Display and write to file spike count/orient relation

			#clearWin = #winConnGraph
			Graphics ($$M_CLEAR)

			file = OPEN(spikeFile$,$$RD)

			IF (rat) THEN 
				temp$ = "Rresporient_" + STRING(SLONG(orOffset!*180)) + ".csv"
			ELSE 
				temp$ = "Cresporient_" + STRING(SLONG(orOffset!*180)) + ".csv"
			END IF

			file1 = OPEN(temp$,$$WR)

			FOR x = 0 TO 141
				FOR y = 0 TO 141
			
					READ [file], spkCount
			
					h = (spkCount/maxSp!) * 500
			
					or! = pyrsAttributes![0,x,y]
			
					WinXDrawFilledRect (#winConnGraph, Pen25, Brush25, or!*5, buttonOffset*m+h, or!*5+3, buttonOffset*m+h+3)
					WinXUpdate (#winConnGraph)
			
					t1$ = STRING(or!)
					t2$ = STRING(spkCount)
					temp$ = t1$ + "," + t2$

					WRITE [file1], temp$

				NEXT y
			NEXT x
			CLOSE(file)
			CLOSE(file1)

		CASE $$M_RECIPAMP
'Calculate and save all reciprocal connection amplitudes

			IF (rat) THEN 
				file = OPEN("RrecipAmpx.csv",$$WR)
				file1 = OPEN("RrecipAmpy.csv",$$WR)
			ELSE 
				file = OPEN("CrecipAmpx.csv",$$WR)
				file1 = OPEN("CrecipAmpy.csv",$$WR)
			END IF

'PRINT "a"

			#clearWin = #winConnGraph
			Graphics ($$M_CLEAR)

PRINT "numRecip =",numRecip

			FOR x = 0 TO numRecip-1

'PRINT "x =",x

				a = (Log10(recipAmp![0,x]) * 50) + 400
				h = (Log10(recipAmp![1,x]) * 50) + 400

'PRINT "a =",a
'PRINT "h =",h 

				WinXDrawFilledRect (#winConnGraph, Pen25, Brush25, a, buttonOffset*m+h, a+3, buttonOffset*m+h+3)
				WinXUpdate (#winConnGraph)

				temp$ = STRING(recipAmp![0,x])

				WRITE [file],temp$,comma$

				temp$ = STRING(recipAmp![1,x])

				WRITE [file1],temp$,comma$

			NEXT x
			CLOSE(file)
			CLOSE(file1)

		CASE $$M_PREPARAMSYN
'plots (in red) difference between cells preferred orient and local preferred orient against difference between (topSyns) largest presyn x locations and cell's x location
'plots same (in blue) for SpF and y location. Saves results.
PRINT "Calculating presyn..."

				file = OPEN("totalXdiff.csv",$$WR)
				file1 = OPEN("cellXdiff.csv",$$WR)
				file2 = OPEN("totalYdiff.csv",$$WR)
				file3 = OPEN("cellYdiff.csv",$$WR)

			DIM origArray [synNum*1.2,2]
			DIM orderArray [0]
			DIM tempArray! [synNum*1.2]
			topSyns = 20

			#clearWin = #winConnGraph
			Graphics ($$M_CLEAR)

			FOR x = 0 TO 141
'PRINT "x =",x
				FOR y = 0 TO 141

					meanX! = x * addOrient!								' These two values from AssignAttributes()
					meanY! = y * addSf!
					or! = pyrsAttributes![0,x,y]
					sf! = pyrsAttributes![1,x,y]

'PRINT "or!,sf! =",or!,sf!

					cellXdiff! = or! - meanX!
					cellYdiff! = sf! - meanY!

					IF cellXdiff! > sdOrient!*5 THEN cellXdiff! = cellXdiff! - 180
					IF cellXdiff! < sdOrient!*-5 THEN cellXdiff! = cellXdiff! + 180
					IF cellYdiff! > sdSf!*5 THEN cellYdiff! = cellYdiff! - 2
					IF cellYdiff! < sdSf!*-5 THEN cellYdiff! = cellYdiff! + 2

'PRINT "cellXdiff!,cellYdiff! =",cellXdiff!,cellYdiff!

					cellXdiff! = cellXdiff! * 142/180
					cellYdiff! = cellYdiff! * 142/2

						FOR z = 0 TO preSynCount[x,y]-1
	
							x1 = preSynCell@@[0,x,y,z]
							y1 = preSynCell@@[1,x,y,z]
				
							FOR j = 0 TO synNum-1
			
								IF ((connMatrix@@[0,x1,y1,j] = x) AND (connMatrix@@[1,x1,y1,j] = y)) THEN EXIT FOR
			
							NEXT j

							tempArray![z] = connStr![x1,y1,j]
							origArray[z,0] = x1
							origArray[z,1] = y1
	
						NEXT z
	
						flag = $$SortDecreasing
						XstQuickSort (@tempArray![], @orderArray[], 0, preSynCount[x,y]-1, flag)
	
						totalXdiff! = 0
						totalYdiff! = 0

						FOR z = 0 TO topSyns - 1
	
							xx = origArray[orderArray[z],0]
							yy = origArray[orderArray[z],1]
	
'PRINT "xx,yy,tempArray![z] =",xx,yy,tempArray![z]

							xDiff = xx - x
							yDiff = yy - y

							IF xDiff > sdOrient!/addOrient!*5 THEN xDiff = xDiff - 141
							IF xDiff < sdOrient!/addOrient!*-5 THEN xDiff = xDiff + 141
							IF yDiff > sdSf!/addSf!*5 THEN yDiff = yDiff - 141
							IF yDiff < sdSf!/addSf!*-5 THEN yDiff = yDiff + 141

'PRINT "xDiff,yDiff =",xDiff,yDiff

							totalXdiff! = totalXdiff! + xDiff
							totalYdiff! = totalYdiff! + yDiff
	
						NEXT z
	
						totalXdiff! = totalXdiff!/topSyns		
						totalYdiff! = totalYdiff!/topSyns
	
'PRINT "totalXdiff!,totalYdiff! =",totalXdiff!,totalYdiff!
	
							a = (totalXdiff! * 5) + 200
			
							h = (cellXdiff! * 5) + 300
			
'PRINT "orient: a,h =",a,h

							WinXDrawFilledRect (#winConnGraph, Pen25, Brush25, a, buttonOffset*m+h, a+3, buttonOffset*m+h+3)
							WinXUpdate (#winConnGraph)
	
							a = (totalYdiff! * 5) + 450
			
							h = (cellYdiff! * 5) + 300
			
'PRINT "SF: a,h =",a,h

							WinXDrawFilledRect (#winConnGraph, Pen0, Brush0, a, buttonOffset*m+h, a+3, buttonOffset*m+h+3)
							WinXUpdate (#winConnGraph)
	
							t1$ = STRING(totalXdiff!)
							t2$ = STRING(cellXdiff!)
			
							WRITE [file],t1$,comma$
							WRITE [file1],t2$,comma$
			
							t1$ = STRING(totalYdiff!)
							t2$ = STRING(cellYdiff!)
			
							WRITE [file2],t1$,comma$
							WRITE [file3],t2$,comma$

				NEXT y
			NEXT x
			CLOSE(file)
			CLOSE(file1)
			CLOSE(file2)
			CLOSE(file3)

		CASE $$M_PARAMSYN
'plots (in red) difference between cells preferred orient and local preferred orient against difference between (topSyns) largest postsyn x locations and cell's x location
'plots same (in blue) for SpF and y location
PRINT "Calculating postsyn..."

				file = OPEN("totalXdiff.csv",$$WR)
				file1 = OPEN("cellXdiff.csv",$$WR)
				file2 = OPEN("totalYdiff.csv",$$WR)
				file3 = OPEN("cellYdiff.csv",$$WR)

			DIM origArray [synNum,2]
			DIM orderArray [0]
			DIM tempArray! [synNum]
			topSyns = 20

			#clearWin = #winConnGraph
			Graphics ($$M_CLEAR)

			FOR x = 0 TO 141
'PRINT "x =",x
				FOR y = 0 TO 141
'			FOR x = 71 TO 71
'				FOR y = 79 TO 79

					meanX! = x * addOrient!								' These two values from AssignAttributes()
					meanY! = y * addSf!
					or! = pyrsAttributes![0,x,y]
					sf! = pyrsAttributes![1,x,y]

'PRINT "or!,sf! =",or!,sf!

					cellXdiff! = or! - meanX!
					cellYdiff! = sf! - meanY!

					IF cellXdiff! > sdOrient!*5 THEN cellXdiff! = cellXdiff! - 180
					IF cellXdiff! < sdOrient!*-5 THEN cellXdiff! = cellXdiff! + 180
					IF cellYdiff! > sdSf!*5 THEN cellYdiff! = cellYdiff! - 2
					IF cellYdiff! < sdSf!*-5 THEN cellYdiff! = cellYdiff! + 2

'PRINT "cellXdiff!,cellYdiff! =",cellXdiff!,cellYdiff!

					cellXdiff! = cellXdiff! * 142/180
					cellYdiff! = cellYdiff! * 142/2

'					IF (ABS(cellXdiff!) > sdOrient!) OR (ABS(cellYdiff!) > sdSf!) THEN

					FOR z = 0 TO synNum-1

						tempArray![z] = connStr![x,y,z]
						origArray[z,0] = connMatrix@@[0,x,y,z]
						origArray[z,1] = connMatrix@@[1,x,y,z]

					NEXT z
	
						flag = $$SortDecreasing
						XstQuickSort (@tempArray![], @orderArray[], 0, synNum-1, flag)
	
						totalXdiff! = 0
						totalYdiff! = 0

						FOR z = 0 TO topSyns - 1
	
							xx = origArray[orderArray[z],0]
							yy = origArray[orderArray[z],1]
	
'PRINT "xx,yy,tempArray![z] =",xx,yy,tempArray![z]

							xDiff = xx - x
							yDiff = yy - y

							IF xDiff > sdOrient!/addOrient!*5 THEN xDiff = xDiff - 141
							IF xDiff < sdOrient!/addOrient!*-5 THEN xDiff = xDiff + 141
							IF yDiff > sdSf!/addSf!*5 THEN yDiff = yDiff - 141
							IF yDiff < sdSf!/addSf!*-5 THEN yDiff = yDiff + 141

'PRINT "xDiff,yDiff =",xDiff,yDiff

							totalXdiff! = totalXdiff! + xDiff
							totalYdiff! = totalYdiff! + yDiff
	
						NEXT z
	
						totalXdiff! = totalXdiff!/topSyns		
						totalYdiff! = totalYdiff!/topSyns
	
'PRINT "totalXdiff!,totalYdiff! =",totalXdiff!,totalYdiff!

'						IF ABS(cellXdiff!) > sdOrient! THEN
	
							a = (totalXdiff! * 5) + 200
			
							h = (cellXdiff! * 5) + 300
			
'PRINT "orient: a,h =",a,h

							WinXDrawFilledRect (#winConnGraph, Pen25, Brush25, a, buttonOffset*m+h, a+3, buttonOffset*m+h+3)
							WinXUpdate (#winConnGraph)
	
'						END IF
	
'						IF ABS(cellYdiff!) > sdSf! THEN
	
							a = (totalYdiff! * 5) + 450
			
							h = (cellYdiff! * 5) + 300
			
'PRINT "SF: a,h =",a,h

							WinXDrawFilledRect (#winConnGraph, Pen0, Brush0, a, buttonOffset*m+h, a+3, buttonOffset*m+h+3)
							WinXUpdate (#winConnGraph)
	
'						END IF
'					END IF

							t1$ = STRING(totalXdiff!)
							t2$ = STRING(cellXdiff!)
			
							WRITE [file],t1$,comma$
							WRITE [file1],t2$,comma$
			
							t1$ = STRING(totalYdiff!)
							t2$ = STRING(cellYdiff!)
			
							WRITE [file2],t1$,comma$
							WRITE [file3],t2$,comma$

				NEXT y
			NEXT x
			CLOSE(file)
			CLOSE(file1)
			CLOSE(file2)
			CLOSE(file3)

		CASE $$M_EPSPORIENT
'Plots and saves EPSP amp against preferred orient for all syns of target cell.

			IF (rat) THEN 
				file = OPEN("EPSPOrient0R.csv",$$WR)
				file1 = OPEN("EPSPOrient1R.csv",$$WR)
			ELSE 
				file = OPEN("EPSPOrient0C.csv",$$WR)
				file1 = OPEN("EPSPOrient1C.csv",$$WR)
			END IF

			x = showx
			y = showy

			#clearWin = #winConnGraph
			Graphics ($$M_CLEAR)

			or1! = pyrsAttributes![0,x,y]

			or1! = (or1!/90) - 1

			FOR z = 0 TO synNum-1

				xx = connMatrix@@[0,x,y,z]
				yy = connMatrix@@[1,x,y,z]

				or2! = pyrsAttributes![0,xx,yy]

				or2! = (or2!/90) - 1

				a! = or1! - or2!
				
				IF (a!>1) THEN
					a! = a! - 2
				END IF
				
				IF (a!<-1) THEN
					a! = a! + 2
				END IF
				
				diff! = ABS(a!)

				a = diff! * 500

				h = connStr![x,y,z]/maxStr! * 500

				WinXDrawFilledRect (#winConnGraph, Pen25, Brush25, a, buttonOffset*m+h, a+3, buttonOffset*m+h+3)
				WinXUpdate (#winConnGraph)

				temp$ = STRING$(diff!)
				WRITE [file],temp$,comma$

'				WRITE [file],diff!,comma$

				temp! = connStr![x,y,z]/maxStr!

IFZ (LEFT$(temp$) = ".") THEN PRINT "1temp$ =", temp$, or1!, or2!

'PRINT z,diff!,temp$,temp!
PRINT z,temp$;

IF (diff! > 1) THEN PRINT "diff! > 1", or1!, or2!

IF (temp! > 1) THEN PRINT "temp! > 1", or1!, or2!

'				WRITE [file1],temp!,comma$
				temp$ = STRING$(temp!)
				WRITE [file1],temp$,comma$


PRINT ,temp$

IFZ (LEFT$(temp$) = ".") THEN PRINT "2temp$ =", temp$, or1!, or2!

IF (temp$ = "28565") THEN PRINT "match", temp$, or1!, or2!

			NEXT z
			CLOSE(file)
			CLOSE(file1)

		CASE $$M_CONNDIST
'Plots prob of conn at 50um intervals

PRINT "Calculating..."

			DIM connAtDist[10]

			#clearWin = #winConnGraph
			Graphics ($$M_CLEAR)

			FOR x = 0 TO 141
				FOR y = 0 TO 141 	
					FOR z = 0 TO synNum-1
		
						xx = connMatrix@@[0,x,y,z]
						yy = connMatrix@@[1,x,y,z]
		
						pd! = CalculatePhyscialDistance (x,y,xx,yy)
		
						d! = maxPhysDist!/10
		
						FOR a = 0 TO 9
		
							r! = d! * a
							r1! = d! * (a+1)
		
							IF ( pd! >= r! ) AND ( pd! < r1! ) THEN INC connAtDist[a] 
		
						NEXT a
					NEXT z
				NEXT y
			NEXT x

			FOR a = 0 TO 9

				PRINT "connAtDist["a"] / cellsAtDist["a"] =",(connAtDist[a]/(142*142)),"/",cellsAtDist[a],"=",SINGLE(connAtDist[a]/(142*142))/SINGLE(cellsAtDist[a])

				WinXDrawFilledRect (#winConnGraph, Pen25, Brush25, a*m*m, buttonOffset*m, a*m*m+m, buttonOffset*m+(SINGLE(connAtDist[a]/(142*142))/SINGLE(cellsAtDist[a]))*2000)
				WinXUpdate (#winConnGraph)

			NEXT a

'		CASE $$M_CONNDIST
''Plots prob of conn at 50um intervals for one cell

'			DIM connAtDist[10]
'			x = showx
'			y = showy

'			#clearWin = #winConnGraph
'			Graphics ($$M_CLEAR)

'			FOR z = 0 TO synNum-1

'				xx = connMatrix@@[0,x,y,z]
'				yy = connMatrix@@[1,x,y,z]

'				pd! = CalculatePhyscialDistance (x,y,xx,yy)

'				d! = maxPhysDist!/10

'				FOR a = 0 TO 9

'					r! = d! * a
'					r1! = d! * (a+1)

'					IF ( pd! >= r! ) AND ( pd! < r1! ) THEN INC connAtDist[a] 

'				NEXT a
'			NEXT z

'				FOR a = 0 TO 9

'					PRINT "connAtDist["a"] / cellsAtDist["a"] =",connAtDist[a],"/",cellsAtDist[a],"=",SINGLE(connAtDist[a])/SINGLE(cellsAtDist[a])

'					WinXDrawFilledRect (#winConnGraph, Pen25, Brush25, a*m*m, buttonOffset*m, a*m*m+m, buttonOffset*m+(SINGLE(connAtDist[a])/SINGLE(cellsAtDist[a]))*2000)
'					WinXUpdate (#winConnGraph)

'				NEXT a


		CASE $$M_COMMCELLS

'Reads from file, displays and writes to new file total common targets/inputs for all cells

PRINT "Calculating all common postsynaptic cells (red) and pre (blue) for all pairs..."

			DIM countCasePost[10]
			DIM countCasePre[10]

			npostMax! = 0
			npreMax! = 0

			#clearWin = #winConnGraph
			Graphics ($$M_CLEAR)

			file = OPEN(commFile$,$$RD)

			IF (rat) THEN 
				file1 = OPEN("Rcommcells.csv",$$WR)
			ELSE 
				file1 = OPEN("Ccommcells.csv",$$WR)
			END IF

			FOR x = 0 TO 141
				FOR y = 0 TO 141

					READ [file],p!
					postCC![x,y] = p!

					FOR z = 0 TO synNum-1
			
						READ [file],npost,npre
			
						IF npost > npostMax! THEN npostMax! = npost
						IF npre > npreMax! THEN npreMax! = npre
			
						numCommonPost%%[x,y,z] = npost
						numCommonPre%%[x,y,z] = npre
			
					NEXT z
				NEXT y
			NEXT x
			CLOSE(file)

			PRINT "npostMax! =",npostMax!
			PRINT "npreMax! =",npreMax!

			FOR x = 0 TO 141
				FOR y = 0 TO 141
					FOR z = 0 TO synNum-1

					npost! = numCommonPost%%[x,y,z]/npostMax!
					npre! = numCommonPre%%[x,y,z]/npreMax!

'			PRINT "npost =",npost
'			PRINT "npre =",npre

					FOR a = 0 TO 9

						IF (npost!*10 > a) AND (npost!*10 <= a+1) THEN INC countCasePost[a]
						IF (npre!*10 > a) AND (npre!*10 <= a+1) THEN INC countCasePre[a]

					NEXT a

					NEXT z
				NEXT y
			NEXT x

			comma$ = ","

			temp$ = "post"

			WRITE [file1],temp$,comma$

			FOR a = 0 TO 9

				s$ = STRING(countCasePost[a])

				WRITE [file1],s$,comma$

			NEXT a

			temp$ = "\r\n"

			WRITE [file1],temp$

			temp$ = "pre"

			WRITE [file1],temp$,comma$

			FOR a = 0 TO 9

				s$ = STRING(countCasePre[a])

				WRITE [file1],s$,comma$

			NEXT a

			CLOSE(file1)

			FOR a = 1 TO 10

PRINT "Post =",countCasePost[a-1]
PRINT "Pre =",countCasePre[a-1]

'PRINT "y value will be",buttonOffset*m+(countCase[a-1]/10000)

				WinXDrawFilledRect (#winConnGraph, Pen25, Brush25, a*m*m, buttonOffset*m, a*m*m+m, buttonOffset*m+(countCasePost[a-1]/10000))
				WinXDrawFilledRect (#winConnGraph, Pen0, Brush0, a*m*m+m, buttonOffset*m, a*m*m+m+m, buttonOffset*m+(countCasePre[a-1]/10000))
				WinXUpdate (#winConnGraph)

			NEXT a

		CASE $$M_NORMPRE

'Calculates, displays and writes to file total normalized presynaptic strengths for all cells

			#clearWin = #winConnGraph
			Graphics ($$M_CLEAR)

			DIM countCase[connCase]

			IF (rat) THEN 
				file = OPEN("RtotalNormPreSynStr.csv",$$WR)
			ELSE 
				file = OPEN("CtotalNormPreSynStr.csv",$$WR)
			END IF

			PRINT "calculating normalized presyn totals..."

			FOR x = 0 TO 141
				FOR y = 0 TO 141

					lMaxStr! = 0

					FOR z = 0 TO preSynCount[x,y]-1
		
						x1 = preSynCell@@[0,x,y,z]
						y1 = preSynCell@@[1,x,y,z]

						FOR j = 0 TO synNum-1
		
							IF ((connMatrix@@[0,x1,y1,j] = x) AND (connMatrix@@[1,x1,y1,j] = y)) THEN EXIT FOR
		
						NEXT j

						IF connStr![x1,y1,j] > lMaxStr! THEN lMaxStr! = connStr![x1,y1,j]
		
					NEXT z

					FOR z = 0 TO preSynCount[x,y]-1

						x1 = preSynCell@@[0,x,y,z]
						y1 = preSynCell@@[1,x,y,z]

						FOR j = 0 TO synNum-1
		
							IF ((connMatrix@@[0,x1,y1,j] = x) AND (connMatrix@@[1,x1,y1,j] = y)) THEN EXIT FOR
		
						NEXT j

						FOR a = 0 TO 9

							IF (connStr![x1,y1,j]/lMaxStr! > a/10.0) AND (connStr![x1,y1,j]/lMaxStr! <= (a+1)/10.0) THEN INC countCase[a]

						NEXT a

					NEXT z
				NEXT y
			NEXT x

			comma$ = ","

			FOR a = 1 TO 10

				s$ = STRING(countCase[a-1])

PRINT "writing to file str =",countCase[a-1]

				WRITE [file],s$,comma$

PRINT "y value will be",buttonOffset*m+(countCase[a-1]/10000)

				WinXDrawFilledRect (#winConnGraph, Pen25, Brush25, a*m*m, buttonOffset*m, a*m*m+m, buttonOffset*m+(countCase[a-1]/10000))
				WinXUpdate (#winConnGraph)

			NEXT a
			CLOSE(file)

		CASE $$M_NORMPOST

'Calculates, displays and writes to file total normalized postsynaptic strengths for all cells

			#clearWin = #winConnGraph
			Graphics ($$M_CLEAR)

			DIM countCase[connCase]

			IF (rat) THEN 
				file = OPEN("RtotalNormPostSynStr.csv",$$WR)
			ELSE 
				file = OPEN("CtotalNormPostSynStr.csv",$$WR)
			END IF

			PRINT "calculating normalized postsyn totals..."

			FOR x = 0 TO 141
				FOR y = 0 TO 141

					lMaxStr! = 0

					FOR z = 0 TO synNum-1
		
						IF connStr![x,y,z] > lMaxStr! THEN lMaxStr! = connStr![x,y,z]
		
					NEXT z

					FOR z = 0 TO synNum-1

						FOR a = 0 TO 9

							IF (connStr![x,y,z]/lMaxStr! > a/10.0) AND (connStr![x,y,z]/lMaxStr! <= (a+1)/10.0) THEN INC countCase[a]

						NEXT a

					NEXT z
				NEXT y
			NEXT x

			comma$ = ","

			FOR a = 1 TO 10

				s$ = STRING(countCase[a-1])

PRINT "writing to file str =",countCase[a-1]

				WRITE [file],s$,comma$

PRINT "y value will be",buttonOffset*m+(countCase[a-1]/10000)

				WinXDrawFilledRect (#winConnGraph, Pen25, Brush25, a*m*m, buttonOffset*m, a*m*m+m, buttonOffset*m+(countCase[a-1]/10000))
				WinXUpdate (#winConnGraph)

			NEXT a
			CLOSE(file)

		CASE $$M_SYNSTR

'Calculates, displays and writes to file total synaptic strengths for all cells

			#clearWin = #winConnGraph
			Graphics ($$M_CLEAR)

			DIM countCase[connCase]
			totAmp! = 0

			IF (rat) THEN 
				file = OPEN("RtotalSynStr.csv",$$WR)
			ELSE 
				file = OPEN("CtotalSynStr.csv",$$WR)
			END IF

			PRINT "calculating totals..."

			FOR x = 0 TO 141
				FOR y = 0 TO 141
					FOR z = 0 TO synNum-1

						totAmp! = totAmp! + connStr![x,y,z]

						FOR a = 0 TO 9

							IF (connStr![x,y,z]/maxStr! > a/10.0) AND (connStr![x,y,z]/maxStr! <= (a+1)/10.0) THEN INC countCase[a]

						NEXT a

					NEXT z
				NEXT y
			NEXT x

			avAmp! = totAmp! / (142*142*synNum)

PRINT "avAmp! =",avAmp!

			comma$ = ","

			FOR a = 1 TO 10

				s$ = STRING(countCase[a-1])

PRINT "writing to file str =",countCase[a-1]

				WRITE [file],s$,comma$

PRINT "y value will be",buttonOffset*m+(countCase[a-1]/10000)

				WinXDrawFilledRect (#winConnGraph, Pen25, Brush25, a*m*m, buttonOffset*m, a*m*m+m, buttonOffset*m+(countCase[a-1]/10000))
				WinXUpdate (#winConnGraph)

			NEXT a
			CLOSE(file)

		CASE $$M_CONNSTR

'Calculates, displays and writes to file total param distances (inverse of correlations) for all synaptic contacts

			#clearWin = #winConnGraph
			Graphics ($$M_CLEAR)

			DIM countCase[11]

			IF (rat) THEN 
				file = OPEN("RtotalSynCorr",$$WR)
				ELSE file = OPEN("CtotalSynCorr",$$WR)
			END IF

			PRINT "calculating totals..."

			FOR x = 0 TO 141
				FOR y = 0 TO 141

					or1! = pyrsAttributes![0,x,y]
					sf1! = pyrsAttributes![1,x,y]
					rp1! = pyrsAttributes![2,x,y]
					p41! = pyrsAttributes![3,x,y]

					FOR z = 0 TO synNum-1

						x1 = connMatrix@@[0,x,y,z]
						y1 = connMatrix@@[1,x,y,z]
			
						or2! = pyrsAttributes![0,x1,y1]
						sf2! = pyrsAttributes![1,x1,y1]
						rp2! = pyrsAttributes![2,x1,y1]
						p42! = pyrsAttributes![3,x1,y1]
			
						dist! = CalculateCellDistance (or1!,sf1!,rp1!,p41!,or2!,sf2!,rp2!,p42!)

						FOR a = 0 TO 10

							IF (dist!*10 > a) AND (dist!*10 <= a+1) THEN INC countCase[a]

						NEXT a

					NEXT z
				NEXT y
			NEXT x

			FOR a = 1 TO 11

				corr = countCase[a-1]

PRINT "writing to file corr =",corr

				WRITE [file], corr

PRINT "y value will be",buttonOffset*m+(countCase[a-1]/5000)

				WinXDrawFilledRect (#winConnGraph, Pen25, Brush25, a*m*m, buttonOffset*m, a*m*m+m, buttonOffset*m+(countCase[a-1]/5000))
				WinXUpdate (#winConnGraph)

			NEXT a
			CLOSE(file)

		CASE $$M_STIMDISTANCES

'Calculates, displays and writes to file total distances between cell attributes. Each distance counted twice so divide by 2

			DIM stimDistance[20]

			IF (rat) THEN 
				file = OPEN("RtotalStimDist",$$WR)
				ELSE file = OPEN("CtotalStimDist",$$WR)
			END IF

			FOR x = 0 TO 141
				FOR y = 0 TO 141

					or1! = pyrsAttributes![0,x,y]
					sf1! = pyrsAttributes![1,x,y]
					rp1! = pyrsAttributes![2,x,y]
					p41! = pyrsAttributes![3,x,y]

					FOR xx = 0 TO 141
						FOR yy = 0 TO 141
			
'							pd! = CalculatePhyscialDistance (x,y,xx,yy)
							IFZ ((x=xx) AND (y=yy)) THEN
				
								or2! = pyrsAttributes![0,xx,yy]
								sf2! = pyrsAttributes![1,xx,yy]
								rp2! = pyrsAttributes![2,xx,yy]
								p42! = pyrsAttributes![3,xx,yy]
		
								dist! = CalculateCellDistance (or1!,sf1!,rp1!,p41!,or2!,sf2!,rp2!,p42!)			
	
								FOR a = 0 TO 19
	
									IF (dist!*10 > a) AND (dist!*10 <= a+1) THEN INC stimDistance[a]
	
								NEXT a
							ENDIF
						NEXT yy
					NEXT xx
				NEXT y
PRINT "x =",x
			NEXT x

			FOR a = 1 TO 20

				stimDist = stimDistance[a-1]

PRINT "writing to file stimDist =",stimDist

				WRITE [file],stimDist

PRINT "stimDistance["STRING$(a-1)"] =",stimDistance[a-1]

				WinXDrawFilledRect (#winStimDistances, Pen25, Brush25, a*m*m, buttonOffset*m, a*m*m+m, buttonOffset*m+(stimDistance[a-1])/100000)
				WinXUpdate (#winStimDistances)

			NEXT a
			CLOSE(file)

		CASE $$M_SHOWPRECORR
	
			DIM countCase[connCase+1]
		
			#clearWin = #winConn
			Graphics ($$M_CLEAR)
			#clearWin = #winConnGraph		
			Graphics ($$M_CLEAR)

			x = showx
			y = showy

			or1! = pyrsAttributes![0,x,y]
			sf1! = pyrsAttributes![1,x,y]
			rp1! = pyrsAttributes![2,x,y]
			p41! = pyrsAttributes![3,x,y]

			PRINT "Drawing cell at x,y ="x,y

			PRINT "or =",pyrsAttributes![0,x,y]
			PRINT "sf =",pyrsAttributes![1,x,y]
			PRINT "rp =",pyrsAttributes![2,x,y]
			PRINT "p4 =",pyrsAttributes![3,x,y]

			WinXDrawFilledRect (#winConn, magentaPen, magentaBrush, x*m, (y+buttonOffset)*m, x*m+m, (y+buttonOffset)*m+m)
			WinXUpdate (#winConn)

			FOR a = 0 TO preSynCount[x,y]-1
		
'PRINT "a =",a

				x1 = preSynCell@@[0,x,y,a]
				y1 = preSynCell@@[1,x,y,a]
	
				or2! = pyrsAttributes![0,x1,y1]
				sf2! = pyrsAttributes![1,x1,y1]
				rp2! = pyrsAttributes![2,x1,y1]
				p42! = pyrsAttributes![3,x1,y1]
	
				dist! = CalculateCellDistance (or1!,sf1!,rp1!,p41!,or2!,sf2!,rp2!,p42!)
		
				SELECT CASE TRUE
		
					CASE dist! > 1.0
						currentPen = Pen0
						currentBrush = Brush0
						INC countCase[0]
					CASE dist! > 0.9
						currentPen = Pen2
						currentBrush = Brush2
						INC countCase[1]
					CASE dist! > 0.8
						currentPen = Pen4
						currentBrush = Brush4
						INC countCase[2]
					CASE dist! > 0.7
						currentPen = Pen7
						currentBrush = Brush7
						INC countCase[3]
					CASE dist! > 0.6
						currentPen = Pen10
						currentBrush = Brush10
						INC countCase[4]
					CASE dist! > 0.5
						currentPen = Pen13
						currentBrush = Brush13
						INC countCase[5]
					CASE dist! > 0.4
						currentPen = Pen16
						currentBrush = Brush16
						INC countCase[6]
					CASE dist! > 0.3
						currentPen = Pen19
						currentBrush = Brush19
						INC countCase[7]
					CASE dist! > 0.2
						currentPen = Pen21
						currentBrush = Brush21
						INC countCase[8]
					CASE dist! > 0.1
						currentPen = Pen23
						currentBrush = Brush23
						INC countCase[9]
					CASE dist! > 0
						currentPen = Pen25
						currentBrush = Brush25
						INC countCase[10]
				END SELECT
		
				'plots color-coded distances between pre and postsynaptic cell for every synapse onto cell x,y ("receptive field")

				WinXDrawFilledRect (#winConn, currentPen, currentBrush, x1*m, (y1+buttonOffset)*m, x1*m+m, (y1+buttonOffset)*m+m)
				WinXUpdate (#winConn)	

			NEXT a

			FOR a = 1 TO connCase+1

				'does bar graph of realtive number of distances of each length for selected cell

				WinXDrawFilledRect (#winConnGraph, Pen25, Brush25, a*m*m, buttonOffset*m, a*m*m+m, buttonOffset*m+(SINGLE(countCase[a-1])/SINGLE(preSynCount[x,y]))*500)
				WinXUpdate (#winConnGraph)

			NEXT a

		CASE $$M_SHOWCORR
	
			DIM countCase[connCase+1]
		
			#clearWin = #winConn
			Graphics ($$M_CLEAR)
			#clearWin = #winConnGraph		
			Graphics ($$M_CLEAR)

			x = showx
			y = showy

			or1! = pyrsAttributes![0,x,y]
			sf1! = pyrsAttributes![1,x,y]
			rp1! = pyrsAttributes![2,x,y]
			p41! = pyrsAttributes![3,x,y]

			PRINT "Drawing cell at x,y ="x,y

			PRINT "or =",pyrsAttributes![0,x,y]
			PRINT "sf =",pyrsAttributes![1,x,y]
			PRINT "rp =",pyrsAttributes![2,x,y]
			PRINT "p4 =",pyrsAttributes![3,x,y]

			WinXDrawFilledRect (#winConn, magentaPen, magentaBrush, x*m, (y+buttonOffset)*m, x*m+m, (y+buttonOffset)*m+m)
			WinXUpdate (#winConn)
		
			FOR a = 0 TO synNum-1
		
				x1 = connMatrix@@[0,x,y,a]
				y1 = connMatrix@@[1,x,y,a]
	
				or2! = pyrsAttributes![0,x1,y1]
				sf2! = pyrsAttributes![1,x1,y1]
				rp2! = pyrsAttributes![2,x1,y1]
				p42! = pyrsAttributes![3,x1,y1]
	
				dist! = CalculateCellDistance (or1!,sf1!,rp1!,p41!,or2!,sf2!,rp2!,p42!)
		
				SELECT CASE TRUE
		
					CASE dist! > 1.0
						currentPen = Pen0
						currentBrush = Brush0
						INC countCase[0]
					CASE dist! > 0.9
						currentPen = Pen2
						currentBrush = Brush2
						INC countCase[1]
					CASE dist! > 0.8
						currentPen = Pen4
						currentBrush = Brush4
						INC countCase[2]
					CASE dist! > 0.7
						currentPen = Pen7
						currentBrush = Brush7
						INC countCase[3]
					CASE dist! > 0.6
						currentPen = Pen10
						currentBrush = Brush10
						INC countCase[4]
					CASE dist! > 0.5
						currentPen = Pen13
						currentBrush = Brush13
						INC countCase[5]
					CASE dist! > 0.4
						currentPen = Pen16
						currentBrush = Brush16
						INC countCase[6]
					CASE dist! > 0.3
						currentPen = Pen19
						currentBrush = Brush19
						INC countCase[7]
					CASE dist! > 0.2
						currentPen = Pen21
						currentBrush = Brush21
						INC countCase[8]
					CASE dist! > 0.1
						currentPen = Pen23
						currentBrush = Brush23
						INC countCase[9]
					CASE dist! > 0
						currentPen = Pen25
						currentBrush = Brush25
						INC countCase[10]
				END SELECT
		
				'plots color-coded distances between pre and postsynaptic cell for every synapse of cell x,y (projected i.e. axonal field)

				WinXDrawFilledRect (#winConn, currentPen, currentBrush, x1*m, (y1+buttonOffset)*m, x1*m+m, (y1+buttonOffset)*m+m)
				WinXUpdate (#winConn)	

			NEXT a

			FOR a = 1 TO connCase+1

				'does bar graph of realtive number of distances of each length for selected cell

				WinXDrawFilledRect (#winConnGraph, Pen25, Brush25, a*m*m, buttonOffset*m, a*m*m+m, buttonOffset*m+(SINGLE(countCase[a-1])/SINGLE(synNum))*500)
				WinXUpdate (#winConnGraph)

			NEXT a


		CASE $$M_DISPLAYPRECONN

			DIM countCase[connCase]
		
			lMaxStr! = 0
		
			#clearWin = #winConn
			Graphics ($$M_CLEAR)
			#clearWin = #winConnGraph		
			Graphics ($$M_CLEAR)

			x = showx
			y = showy

			PRINT "Drawing cell at x,y ="x,y

			FOR z = 0 TO preSynCount[x,y]-1

				x1 = preSynCell@@[0,x,y,z]
				y1 = preSynCell@@[1,x,y,z]

				FOR k = 0 TO synNum-1

					IF ((connMatrix@@[0,x1,y1,k] = x) AND (connMatrix@@[1,x1,y1,k] = y)) THEN EXIT FOR

				NEXT k

				IF connStr![x1,y1,k] > lMaxStr! THEN lMaxStr! = connStr![x1,y1,k]

			NEXT z

			PRINT "lMaxStr! =",lMaxStr!
			PRINT "or =",pyrsAttributes![0,x,y]
			PRINT "sf =",pyrsAttributes![1,x,y]
			PRINT "rp =",pyrsAttributes![2,x,y]
			PRINT "p4 =",pyrsAttributes![3,x,y]

			WinXDrawFilledRect (#winConn, magentaPen, magentaBrush, x*m, (y+buttonOffset)*m, x*m+m, (y+buttonOffset)*m+m)
			WinXUpdate (#winConn)

			FOR a = 0 TO preSynCount[x,y]-1
		
'PRINT "a =",a

				x1 = preSynCell@@[0,x,y,a]
				y1 = preSynCell@@[1,x,y,a]
		
				FOR z = 0 TO synNum-1

					IF ((connMatrix@@[0,x1,y1,z] = x) AND (connMatrix@@[1,x1,y1,z] = y)) THEN EXIT FOR

				NEXT z

				relStr! = connStr![x1,y1,z]/lMaxStr!

'IF (z > 498) THEN PRINT "a,z =",a,z

'PRINT "z =",z

				SELECT CASE TRUE
		
					CASE relStr! < 0.1
						currentPen = Pen0
						currentBrush = Brush0
						INC countCase[0]
					CASE relStr! < 0.2
						currentPen = Pen2
						currentBrush = Brush2
						INC countCase[1]
					CASE relStr! < 0.3
						currentPen = Pen4
						currentBrush = Brush4
						INC countCase[2]
					CASE relStr! < 0.4
						currentPen = Pen7
						currentBrush = Brush7
						INC countCase[3]
					CASE relStr! < 0.5
						currentPen = Pen10
						currentBrush = Brush10
						INC countCase[4]
					CASE relStr! < 0.6
						currentPen = Pen13
						currentBrush = Brush13
						INC countCase[5]
					CASE relStr! < 0.7
						currentPen = Pen16
						currentBrush = Brush14
						INC countCase[6]
					CASE relStr! < 0.8
						currentPen = Pen19
						currentBrush = Brush19
						INC countCase[7]
					CASE relStr! < 0.9
						currentPen = Pen22
						currentBrush = Brush22
						INC countCase[8]
					CASE relStr! <= 1.0
						currentPen = Pen25
						currentBrush = Brush25
						INC countCase[9]
'PRINT "biggest synapse"
				END SELECT
		
				'plots color-coded synaptic strengths for every cell presynaptic to x,y ("receptive field")

				WinXDrawFilledRect (#winConn, currentPen, currentBrush, x1*m, (y1+buttonOffset)*m, x1*m+m, (y1+buttonOffset)*m+m)
				WinXUpdate (#winConn)	

			NEXT a

			FOR a = 1 TO connCase

				'does bar graph of realtive number of presynaptic connections of each strength for selected cell

				WinXDrawFilledRect (#winConnGraph, Pen25, Brush25, a*m*m, buttonOffset*m, a*m*m+m, buttonOffset*m+(SINGLE(countCase[a-1])/SINGLE(preSynCount[x,y]))*500)
				WinXUpdate (#winConnGraph)

'				WinXDrawLine (#winConnGraph, Pen25, a*m*m, buttonOffset, a*m*m+m, buttonOffset+100)

'PRINT "synNum =",synNum
'PRINT "countCase[a-1] =",countCase[a-1]
'PRINT "SINGLE(countCase[a-1])/SINGLE(synNum))*500 =",(SINGLE(countCase[a-1])/SINGLE(synNum))*500

			NEXT a


		CASE $$M_SHOWCONN
	
			DIM countCase[connCase]

			lMaxStr! = 0
		
			#clearWin = #winConn
			Graphics ($$M_CLEAR)
			#clearWin = #winConnGraph		
			Graphics ($$M_CLEAR)

			x = showx
			y = showy

			PRINT "Drawing cell at x,y ="x,y

			FOR z = 0 TO synNum-1

				IF connStr![x,y,z] > lMaxStr! THEN lMaxStr! = connStr![x,y,z]

			NEXT z

			PRINT "lMaxStr! =",lMaxStr!
			PRINT "or =",pyrsAttributes![0,x,y]
			PRINT "sf =",pyrsAttributes![1,x,y]
			PRINT "rp =",pyrsAttributes![2,x,y]
			PRINT "p4 =",pyrsAttributes![3,x,y]

			WinXDrawFilledRect (#winConn, magentaPen, magentaBrush, x*m, (y+buttonOffset)*m, x*m+m, (y+buttonOffset)*m+m)
			WinXUpdate (#winConn)
		
			FOR a = 0 TO synNum-1
		
				x1 = connMatrix@@[0,x,y,a]
				y1 = connMatrix@@[1,x,y,a]
				relStr! = connStr![x,y,a]/lMaxStr!
		
				SELECT CASE TRUE
		
					CASE relStr! < 0.1
						currentPen = Pen0
						currentBrush = Brush0
						INC countCase[0]
					CASE relStr! < 0.2
						currentPen = Pen2
						currentBrush = Brush2
						INC countCase[1]
					CASE relStr! < 0.3
						currentPen = Pen4
						currentBrush = Brush4
						INC countCase[2]
					CASE relStr! < 0.4
						currentPen = Pen7
						currentBrush = Brush7
						INC countCase[3]
					CASE relStr! < 0.5
						currentPen = Pen10
						currentBrush = Brush10
						INC countCase[4]
					CASE relStr! < 0.6
						currentPen = Pen13
						currentBrush = Brush13
						INC countCase[5]
					CASE relStr! < 0.7
						currentPen = Pen16
						currentBrush = Brush14
						INC countCase[6]
					CASE relStr! < 0.8
						currentPen = Pen19
						currentBrush = Brush19
						INC countCase[7]
					CASE relStr! < 0.9
						currentPen = Pen22
						currentBrush = Brush22
						INC countCase[8]
					CASE relStr! <= 1.0
						currentPen = Pen25
						currentBrush = Brush25
						INC countCase[9]
'PRINT "biggest synapse"
				END SELECT
		
				'plots color-coded synaptic strengths for every synapse of cell x,y (projected i.e. axonal field)

				WinXDrawFilledRect (#winConn, currentPen, currentBrush, x1*m, (y1+buttonOffset)*m, x1*m+m, (y1+buttonOffset)*m+m)
				WinXUpdate (#winConn)	

			NEXT a

			FOR a = 1 TO connCase

				'does bar graph of realtive number of connections of each strength for selected cell

				WinXDrawFilledRect (#winConnGraph, Pen25, Brush25, a*m*m, buttonOffset*m, a*m*m+m, buttonOffset*m+(SINGLE(countCase[a-1])/SINGLE(synNum))*500)
				WinXUpdate (#winConnGraph)

'				WinXDrawLine (#winConnGraph, Pen25, a*m*m, buttonOffset, a*m*m+m, buttonOffset+100)

'PRINT "synNum =",synNum
'PRINT "countCase[a-1] =",countCase[a-1]
'PRINT "SINGLE(countCase[a-1])/SINGLE(synNum))*500 =",(SINGLE(countCase[a-1])/SINGLE(synNum))*500

			NEXT a


		CASE $$M_2CLOSEST
			
			WinXClear (#winStim)
			WinXUpdate (#winStim)

			DIM active0! [totCells,3]
			DIM active1! [totCells,3]
			
			file0 = OPEN(distFile0$,$$RD)
			file1 = OPEN(distFile1$,$$RD)
			
			FOR a = 0 TO totCells-1

				READ [file0],x0,y0,d0!
				READ [file1],x1,y1,d1!

'PRINT "reading from file x0,y0,d0! = " x0,y0,d0!

				active0![a,0] = x0
				active0![a,1] = y0
				active0![a,2] = d0!

				active1![a,0] = x1
				active1![a,1] = y1
				active1![a,2] = d1!

			NEXT a
			
			CLOSE(file0)
			CLOSE(file1)
			
			currentPen = Pen25
			currentBrush = Brush25
		
			FOR a = 0 TO totCells-1
		
				WinXDrawFilledRect (#winStim, currentPen, currentBrush, active0![a,0]*m, (active0![a,1]+buttonOffset)*m, active0![a,0]*m+m, (active0![a,1]+buttonOffset)*m+m)
				WinXUpdate (#winStim)
		
			NEXT a

			currentPen = Pen13
			currentBrush = Brush13
		
			FOR a = 0 TO totCells-1
		
				WinXDrawFilledRect (#winStim, currentPen, currentBrush, active1![a,0]*m, (active1![a,1]+buttonOffset)*m, active1![a,0]*m+m, (active1![a,1]+buttonOffset)*m+m)
				WinXUpdate (#winStim)
		
			NEXT a

			currentPen = Pen19
			currentBrush = Brush19
		
			overlap! = 0
		
			FOR a = 0 TO totCells-1
				FOR b = 0 TO totCells-1

					IF ((active0![a,0] = active1![b,0]) AND (active0![a,1] = active1![b,1])) THEN

						WinXDrawFilledRect (#winStim, currentPen, currentBrush, active0![a,0]*m, (active0![a,1]+buttonOffset)*m, active0![a,0]*m+m, (active0![a,1]+buttonOffset)*m+m)
						WinXUpdate (#winStim)
		
						INC overlap!
		
					ENDIF
				NEXT b
			NEXT a

PRINT "orientation difference = ",orOffset!*180
PRINT "totCells = ",totCells
PRINT "overlap % = ",(overlap!/totCells)*100

		CASE $$M_CLOSEST
			WinXClear (#winStim)
			WinXUpdate (#winStim)

			currentPen = Pen25
			currentBrush = Brush25
		
			file = OPEN(distFile0$,$$RD)
		
			FOR a = 0 TO totCells-1
		
				READ [file],x,y,d!
		
'		PRINT "reading from file x,y,d! = " x,y,d!
		
							WinXDrawFilledRect (#winStim, currentPen, currentBrush, x*m, (y+buttonOffset)*m, x*m+m, (y+buttonOffset)*m+m)
							WinXUpdate (#winStim)
		
			NEXT a
			CLOSE(file)

'PRINT "last read from file x,y,d! = " x,y,d!

		CASE $$M_OR
			WinXClear (#winAtt)
			WinXUpdate (#winAtt)
	
			FOR x = 0 TO 141
				FOR y = 0 TO 141
		
				SELECT CASE TRUE
		
					CASE pyrsAttributes![0,x,y] < 10
						currentPen = Pen15
						currentBrush = Brush15
					CASE pyrsAttributes![0,x,y] < 20
						currentPen = Pen16
						currentBrush = Brush16
					CASE pyrsAttributes![0,x,y] < 30
						currentPen = Pen17
						currentBrush = Brush17
					CASE pyrsAttributes![0,x,y] < 40
						currentPen = Pen18
						currentBrush = Brush18
					CASE pyrsAttributes![0,x,y] < 50
						currentPen = Pen19
						currentBrush = Brush19
					CASE pyrsAttributes![0,x,y] < 60
						currentPen = Pen20
						currentBrush = Brush20
					CASE pyrsAttributes![0,x,y] < 70
						currentPen = Pen21
						currentBrush = Brush21
					CASE pyrsAttributes![0,x,y] < 80
						currentPen = Pen22
						currentBrush = Brush22
					CASE pyrsAttributes![0,x,y] < 90
						currentPen = Pen23
						currentBrush = Brush23
					CASE pyrsAttributes![0,x,y] < 100
						currentPen = Pen24
						currentBrush = Brush24
					CASE pyrsAttributes![0,x,y] < 110
						currentPen = Pen25
						currentBrush = Brush25
					CASE pyrsAttributes![0,x,y] < 120
						currentPen = Pen0
						currentBrush = Brush0
					CASE pyrsAttributes![0,x,y] < 130
						currentPen = Pen1
						currentBrush = Brush1
					CASE pyrsAttributes![0,x,y] < 140
						currentPen = Pen2
						currentBrush = Brush2
					CASE pyrsAttributes![0,x,y] < 150
						currentPen = Pen3
						currentBrush = Brush3
					CASE pyrsAttributes![0,x,y] < 160
						currentPen = Pen4
						currentBrush = Brush4
					CASE pyrsAttributes![0,x,y] < 170
						currentPen = Pen5
						currentBrush = Brush5
					CASE pyrsAttributes![0,x,y] < 181
						currentPen = Pen6
						currentBrush = Brush6
				END SELECT
	
				WinXDrawFilledRect (#winAtt, currentPen, currentBrush, x*m, (y+buttonOffset)*m, x*m+m, (y+buttonOffset)*m+m)
				WinXUpdate (#winAtt)
	
				NEXT y
			NEXT x

'PRINT "Or display finished"

		CASE $$M_SPFQ
			WinXClear (#winAtt)
			WinXUpdate (#winAtt)

			FOR y = 0 TO 141
				FOR x = 0 TO 141

				SELECT CASE TRUE

					CASE pyrsAttributes![1,x,y] < 0.1
						currentPen = Pen13
						currentBrush = Brush13
					CASE pyrsAttributes![1,x,y] < 0.2
						currentPen = Pen14
						currentBrush = Brush14
					CASE pyrsAttributes![1,x,y] < 0.3
						currentPen = Pen15
						currentBrush = Brush15
					CASE pyrsAttributes![1,x,y] < 0.4
						currentPen = Pen16						
						currentBrush = Brush16
					CASE pyrsAttributes![1,x,y] < 0.5
						currentPen = Pen17						
						currentBrush = Brush17
					CASE pyrsAttributes![1,x,y] < 0.6
						currentPen = Pen18						
						currentBrush = Brush18
					CASE pyrsAttributes![1,x,y] < 0.7
						currentPen = Pen19						
						currentBrush = Brush19
					CASE pyrsAttributes![1,x,y] < 0.8
						currentPen = Pen20						
						currentBrush = Brush20
					CASE pyrsAttributes![1,x,y] < 0.9
						currentPen = Pen21						
						currentBrush = Brush21
					CASE pyrsAttributes![1,x,y] < 1
						currentPen = Pen22						
						currentBrush = Brush22
					CASE pyrsAttributes![1,x,y] < 1.1
						currentPen = Pen23						
						currentBrush = Brush23
					CASE pyrsAttributes![1,x,y] < 1.2
						currentPen = Pen24						
						currentBrush = Brush24
					CASE pyrsAttributes![1,x,y] < 1.3
						currentPen = Pen25						
						currentBrush = Brush25
					CASE pyrsAttributes![1,x,y] < 1.4
						currentPen = Pen0						
						currentBrush = Brush0
					CASE pyrsAttributes![1,x,y] < 1.5
						currentPen = Pen1						
						currentBrush = Brush1
					CASE pyrsAttributes![1,x,y] < 1.6
						currentPen = Pen2						
						currentBrush = Brush2
					CASE pyrsAttributes![1,x,y] < 1.7
						currentPen = Pen3						
						currentBrush = Brush3
					CASE pyrsAttributes![1,x,y] < 1.8
						currentPen = Pen4						
						currentBrush = Brush4
					CASE pyrsAttributes![1,x,y] < 1.9
						currentPen = Pen5						
						currentBrush = Brush5
					CASE pyrsAttributes![1,x,y] < 1000
						currentPen = Pen6						
						currentBrush = Brush6

				END SELECT

				WinXDrawFilledRect (#winAtt, currentPen, currentBrush, x*m, (y+buttonOffset)*m, x*m+m, (y+buttonOffset)*m+m)
				WinXUpdate (#winAtt)

				NEXT x
			NEXT y

		CASE $$M_RND
			WinXClear (#winAtt)
			WinXUpdate (#winAtt)

			FOR y = 0 TO 141
				FOR x = 0 TO 141

				SELECT CASE TRUE

					CASE pyrsAttributes![2,x,y] < 0.055555
						currentPen = Pen15						
						currentBrush = Brush15
					CASE pyrsAttributes![2,x,y] < 0.111111
						currentPen = Pen16						
						currentBrush = Brush16
					CASE pyrsAttributes![2,x,y] < 0.166666
						currentPen = Pen17						
						currentBrush = Brush17
					CASE pyrsAttributes![2,x,y] < 0.222222
						currentPen = Pen18						
						currentBrush = Brush18
					CASE pyrsAttributes![2,x,y] < 0.277777
						currentPen = Pen19						
						currentBrush = Brush19
					CASE pyrsAttributes![2,x,y] < 0.333333
						currentPen = Pen20						
						currentBrush = Brush20
					CASE pyrsAttributes![2,x,y] < 0.388888
						currentPen = Pen21						
						currentBrush = Brush21
					CASE pyrsAttributes![2,x,y] < 0.444444
						currentPen = Pen22						
						currentBrush = Brush22
					CASE pyrsAttributes![2,x,y] < 0.499999
						currentPen = Pen23						
						currentBrush = Brush23
					CASE pyrsAttributes![2,x,y] < 0.555555
						currentPen = Pen24						
						currentBrush = Brush24
					CASE pyrsAttributes![2,x,y] < 0.611111
						currentPen = Pen25						
						currentBrush = Brush25
					CASE pyrsAttributes![2,x,y] < 0.666666
						currentPen = Pen0						
						currentBrush = Brush0
					CASE pyrsAttributes![2,x,y] < 0.722222
						currentPen = Pen1					
						currentBrush = Brush1
					CASE pyrsAttributes![2,x,y] < 0.777777
						currentPen = Pen2						
						currentBrush = Brush2
					CASE pyrsAttributes![2,x,y] < 0.833333
						currentPen = Pen3						
						currentBrush = Brush3
					CASE pyrsAttributes![2,x,y] < 0.888888
						currentPen = Pen4						
						currentBrush = Brush4
					CASE pyrsAttributes![2,x,y] < 0.944444
						currentPen = Pen5						
						currentBrush = Brush5
					CASE pyrsAttributes![2,x,y] <= 1
						currentPen = Pen6						
						currentBrush = Brush6

				END SELECT

				WinXDrawFilledRect (#winAtt, currentPen, currentBrush, x*m, (y+buttonOffset)*m, x*m+m, (y+buttonOffset)*m+m)
				WinXUpdate (#winAtt)

				NEXT x
			NEXT y

		CASE $$M_P4
			WinXClear (#winAtt)
			WinXUpdate (#winAtt)

			FOR y = 0 TO 141
				FOR x = 0 TO 141

				SELECT CASE TRUE

					CASE pyrsAttributes![3,x,y] < 0.055555
						currentPen = Pen15						
						currentBrush = Brush15
					CASE pyrsAttributes![3,x,y] < 0.111111
						currentPen = Pen16						
						currentBrush = Brush16
					CASE pyrsAttributes![3,x,y] < 0.166666
						currentPen = Pen17						
						currentBrush = Brush17
					CASE pyrsAttributes![3,x,y] < 0.222222
						currentPen = Pen18						
						currentBrush = Brush18
					CASE pyrsAttributes![3,x,y] < 0.277777
						currentPen = Pen19						
						currentBrush = Brush19
					CASE pyrsAttributes![3,x,y] < 0.333333
						currentPen = Pen20						
						currentBrush = Brush20
					CASE pyrsAttributes![3,x,y] < 0.388888
						currentPen = Pen21						
						currentBrush = Brush21
					CASE pyrsAttributes![3,x,y] < 0.444444
						currentPen = Pen22						
						currentBrush = Brush22
					CASE pyrsAttributes![3,x,y] < 0.499999
						currentPen = Pen23						
						currentBrush = Brush23
					CASE pyrsAttributes![3,x,y] < 0.555555
						currentPen = Pen24						
						currentBrush = Brush24
					CASE pyrsAttributes![3,x,y] < 0.611111
						currentPen = Pen25						
						currentBrush = Brush25
					CASE pyrsAttributes![3,x,y] < 0.666666
						currentPen = Pen0						
						currentBrush = Brush0
					CASE pyrsAttributes![3,x,y] < 0.722222
						currentPen = Pen1					
						currentBrush = Brush1
					CASE pyrsAttributes![3,x,y] < 0.777777
						currentPen = Pen2						
						currentBrush = Brush2
					CASE pyrsAttributes![3,x,y] < 0.833333
						currentPen = Pen3						
						currentBrush = Brush3
					CASE pyrsAttributes![3,x,y] < 0.888888
						currentPen = Pen4						
						currentBrush = Brush4
					CASE pyrsAttributes![3,x,y] < 0.944444
						currentPen = Pen5						
						currentBrush = Brush5
					CASE pyrsAttributes![3,x,y] <= 1
						currentPen = Pen6						
						currentBrush = Brush6

				END SELECT
	
				WinXDrawFilledRect (#winAtt, currentPen, currentBrush, x*m, (y+buttonOffset)*m, x*m+m, (y+buttonOffset)*m+m)
				WinXUpdate (#winAtt)

				NEXT x
			NEXT y

		CASE $$M_CLEAR
			WinXClear (#clearWin)
			WinXUpdate (#clearWin)
			WinXClear (#clearWin)
			WinXUpdate (#clearWin)

	END SELECT

END FUNCTION